<div id="et_dashboard" class="wrap bootstrap-et">
    <?php 

    global $__Expt_BaseController, $__Expt_ApiCallbacks, $__Expt_NewsletterCallbacks;

    // Refresh to get current balance from API
    if( (get_current_screen()->base == 'toplevel_page_et_menu') || (isset($_GET['refreshBal']) && $_GET['refreshBal'] == 'true') ){
        $refreshChk = isset($_GET['refreshBal']) ? sanitize_text_field( $_GET['refreshBal'] ) : '';
        $__Expt_ApiCallbacks->refreshBal($refreshChk);
    }
    
    ?>

    <div class="container-fluid px-0">
        <?php $__Expt_BaseController->plugin_et_header(); ?>
        <div class="px-3 py-2">
            <h2 class="m-0 p-0"></h2>
            <div class="row">
                <div class="col-md-6">
                    <div class="card mb-4" id="et_balance_loader">
                        <h5 class="card-header"><?php _e( 'Remaining Balance', 'experttexting-official' ) ?></h5>
                        <div class="card-body">
                            <div class="d-flex align-items-center justify-content-between flex-row">
                                <?php if (!empty(get_option( 'et_balance' ))) { ?>
                                    <div class="d-flex">
                                        <span class="dashicons dashicons-money-alt h3"></span> <h3><?php _e( 'Balance', 'experttexting-official' ) ?></h3>
                                    </div>
                                    <div class="d-flex h3">
                                        <?php _e( '$' . esc_attr( get_option( 'et_balance' ) ) . ' <a title="' . __( 'Refresh', 'experttexting-official' ) . '" onclick="et_loader(\'#et_balance_loader\')" class="text-dark et_refresh_balance" href=' . admin_url("admin.php?page=et_menu&refreshBal=true") . '><span class="dashicons dashicons-update-alt h3"></span></a>' ); ?>
                                    </div>
                                <?php } else { ?>
                                    <div class="d-flex">
                                    <span class="dashicons dashicons-admin-generic h5"></span> <h5><?php _e( 'Configure your API settings', 'experttexting-official' ) ?> - <a href='<?php esc_attr_e( admin_url("admin.php?page=et_settings&sub=api") ) ?>' class="text-success"><?php _e( 'Click Here', 'experttexting-official' ) ?></a></h5>
                                    </div>
                                    
                                <?php } ?>
                                </div>
                        </div>
                    </div>

                    <?php if (!empty(get_option( 'et_balance' ))) { ?>
                        <div class="card mb-4">
                            <h5 class="card-header"><?php _e( 'Recharge Account', 'experttexting-official' ) ?></h5>
                            <div class="card-body p-2">
                                <div class="d-flex align-items-center justify-content-center flex-column">
                                    <?php if ( get_option( 'et_balance' ) < 0.20 ) { ?>

                                        <div class="py-2">
                                            <h6 class="m-0"><span class="dashicons dashicons-info-outline my-0"></span><?php _e( 'Your account credit is too low. Please recharge!', 'experttexting-official' ) ?></h6>
                                        </div>
                                        <div class="py-2">
                                            <a href="https://www.experttexting.com/appv2/Payments" target="_blank" class="btn btn-danger"><span class="dashicons dashicons-update-alt"></span><?php _e( 'Recharge', 'experttexting-official' ) ?></a>
                                        </div>

                                    <?php } else { ?>

                                        <div class="py-2">
                                            <a href="https://www.experttexting.com/appv2/Payments" target="_blank" class="btn btn-success"><span class="dashicons dashicons-update-alt"></span><?php _e( 'Recharge Balance', 'experttexting-official' ) ?></a>
                                        </div>

                                    <?php } ?>
                                </div>
                            </div>
                        </div>
                    <?php } ?>

                    <div class="card mb-4" >
                        <div class="card-header">
                            <div class="d-flex align-items-center justify-content-between flex-row">
                                <div class="d-flex">
                                    <h5 class="mb-0"><?php _e( 'Subscribers', 'experttexting-official' ) ?></h5>
                                </div>
                                <div class="d-flex h6 mb-0">
                                    <a href='<?php esc_attr_e( admin_url("admin.php?page=et_subscribers") ) ?>' class="text-success"><?php _e( 'View All', 'experttexting-official' ) ?></a>
                                </div>
                            </div>
                        </div>
                        <ul class="list-group list-group-flush">

                            <li class="list-group-item mb-0">
                                <div class="d-flex align-items-center justify-content-between flex-row">
                                    <div class="d-flex">
                                        <span class="dashicons dashicons-yes-alt h5 text-success my-2"></span> <h5 class="my-2"><?php _e( 'Active Subscribers', 'experttexting-official' ) ?></h5>
                                    </div>
                                    <div class="d-flex h5 my-2">
                                        <?php esc_attr_e( absint($__Expt_NewsletterCallbacks->getSubsCount("1")) ); ?>
                                    </div>
                                </div>
                            </li>
                            <li class="list-group-item mb-0">
                                <div class="d-flex align-items-center justify-content-between flex-row">
                                    <div class="d-flex">
                                        <span class="dashicons dashicons-dismiss h5 text-danger my-2"></span> <h5 class="my-2"><?php _e( 'Inactive Subscribers', 'experttexting-official' ) ?></h5>
                                    </div>
                                    <div class="d-flex h5 my-2">
                                        <?php esc_attr_e( absint($__Expt_NewsletterCallbacks->getSubsCount("0")) ); ?>
                                    </div>
                                </div>
                            </li>

                        </ul>
                    </div>

                    <div class="card mb-4">
                        <div class="card-header">
                            <div class="d-flex align-items-center justify-content-between flex-row">
                                <div class="d-flex">
                                    <h5 class="mb-0"><?php _e( 'Groups', 'experttexting-official' ) ?></h5>
                                </div>
                                <div class="d-flex h6 mb-0">
                                    <a href='<?php esc_attr_e( admin_url("admin.php?page=et_subscribers_group") ) ?>' class="text-success"><?php _e( 'View All', 'experttexting-official' ) ?></a>
                                </div>
                            </div>
                        </div>
                        <ul class="list-group list-group-flush">

                            <li class="list-group-item mb-0">
                                <div class="d-flex align-items-center justify-content-between flex-row">
                                    <div class="d-flex">
                                        <span class="dashicons dashicons-groups my-2"></span> <h5 class="my-2"><?php _e( 'Total Groups', 'experttexting-official' ) ?></h5>
                                    </div>
                                    <div class="d-flex h5 my-2">
                                        <?php esc_attr_e( ($__Expt_NewsletterCallbacks->getGroups() ? absint(count($__Expt_NewsletterCallbacks->getGroups())) : 0) ); ?>
                                    </div>
                                </div>
                            </li>

                        </ul>
                    </div>

                </div>
                <div class="col-md-6">
                    <div class="card mb-4">
                        <h5 class="card-header"><?php _e( "ExpertTexting's Account Status", 'experttexting-official' ) ?></h5>                        

                        <?php if( empty( get_option( 'etApiAuth' ) ) && !empty( $__Expt_BaseController->apiValues ) ) { ?>

                            <ul class="list-group list-group-flush">
                        
                                <li class="list-group-item mb-0">
                                    <div class="d-flex align-items-center justify-content-between flex-row">
                                        <div class="d-flex">
                                            <h5 class="my-2"><?php _e( 'Username:', 'experttexting-official' ) ?></h5>
                                        </div>
                                        <div class="d-flex h5 my-2">
                                            <?php
                                            esc_attr_e( (!$__Expt_BaseController->apiUsername ? "-" : $__Expt_BaseController->apiUsername) );
                                            ?>
                                        </div>
                                    </div>
                                </li>
                                <li class="list-group-item mb-0">
                                    <div class="d-flex align-items-center justify-content-between flex-row">
                                        <div class="d-flex">
                                            <h5 class="my-2"><?php _e( 'API Status:', 'experttexting-official' ) ?></h5>
                                        </div>
                                        <div class="d-flex">
                                            <?php $__Expt_ApiCallbacks->etApiSetStatus('dashboard'); ?>
                                        </div>
                                    </div>
                                </li>

                            </ul>
                                
                        <?php } elseif( !empty( get_option( 'etApiAuth' ) ) ) { ?>

                            <ul class="list-group list-group-flush">
                        
                                <li class="list-group-item mb-0">
                                    <div class="d-flex align-items-start justify-content-between flex-column">
                                        <div class="d-flex">
                                            <p class="text-danger mb-3 fw-bold"><?php esc_attr_e( get_option( 'etApiAuth' ) ) ?></p>
                                        </div>
                                        <div class="d-flex">
                                            <h6><?php _e( 'Please configure the API settings', 'experttexting-official' ) ?> - <a href='<?php esc_attr_e( admin_url("admin.php?page=et_settings&sub=api") ) ?>' class="text-danger"><?php _e( 'Click Here', 'experttexting-official' ) ?></a></h6>
                                        </div>
                                    </div>
                                </li>
                                <li class="list-group-item mb-0">
                                    <div class="d-flex align-items-center justify-content-between flex-row">
                                        <div class="d-flex">
                                            <h5 class="my-2"><?php _e( 'API Status:', 'experttexting-official' ) ?></h5>
                                        </div>
                                        <div class="d-flex">
                                            <?php $__Expt_ApiCallbacks->etApiSetStatus('dashboard'); ?>
                                        </div>
                                    </div>
                                </li>

                            </ul>
                            
                        <?php } ?>
                            
                        <div class="card-body">
                            <div class="d-flex align-items-center justify-content-between flex-row py-2">
                                <div class="d-flex">
                                    <p class="h6"><?php _e( "Login to your ExpertTexting's Account or Change Settings.", 'experttexting-official' ) ?> <a href="https://www.experttexting.com/appv2" target="_blank" class="text-success"><?php _e( 'Click Here', 'experttexting-official' ) ?></a> </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="card mb-4">
                        <div class="card-header">
                            <div class="d-flex align-items-center justify-content-between flex-row">
                                <div class="d-flex">
                                    <h5 class="mb-0"><?php _e( 'Messages Details', 'experttexting-official' ) ?></h5>
                                </div>
                                <div class="d-flex h6 mb-0">
                                    <a href='<?php esc_attr_e( admin_url("admin.php?page=et_subscribers_outbox") ) ?>' class="text-success"><?php _e( 'View All', 'experttexting-official' ) ?></a>
                                </div>
                            </div>
                        </div>
                        <ul class="list-group list-group-flush">

                            <li class="list-group-item mb-0">
                                <div class="d-flex align-items-center justify-content-between flex-row">
                                    <div class="d-flex">
                                        <span class="dashicons dashicons-admin-comments h5 my-2"></span> <h5 class="my-2"><?php _e( 'Total Messages Sent', 'experttexting-official' ) ?></h5>
                                    </div>
                                    <div class="d-flex h5 my-2">
                                        <?php esc_attr_e( ($__Expt_ApiCallbacks->getMessageSendCount() ? absint($__Expt_ApiCallbacks->getMessageSendCount()) : 0) ); ?>
                                    </div>
                                </div>
                            </li>
                            <li class="list-group-item mb-0">
                                <div class="d-flex align-items-center justify-content-between flex-row">
                                    <div class="d-flex">
                                        <span class="dashicons dashicons-dismiss h5 text-danger my-2"></span> <h5 class="my-2"><?php _e( 'Failed Messages', 'experttexting-official' ) ?></h5>
                                    </div>
                                    <div class="d-flex h5 my-2">
                                        <?php esc_attr_e( ($__Expt_ApiCallbacks->getMessageSendCount('failed') ? absint($__Expt_ApiCallbacks->getMessageSendCount('failed')) : 0) ); ?>
                                    </div>
                                </div>
                            </li>
                            <li class="list-group-item mb-0">
                                <div class="d-flex align-items-center justify-content-between flex-row">
                                    <div class="d-flex">
                                        <span class="dashicons dashicons-yes-alt h5 text-success my-2"></span> <h5 class="my-2"><?php _e( 'Successful Messages', 'experttexting-official' ) ?></h5>
                                    </div>
                                    <div class="d-flex h5 my-2">
                                        <?php esc_attr_e( ($__Expt_ApiCallbacks->getMessageSendCount('success') ? absint($__Expt_ApiCallbacks->getMessageSendCount('success')) : 0) ); ?>
                                    </div>
                                </div>
                            </li>

                        </ul>
                    </div>

                </div>

            </div>
        </div>
        
    </div>
    
</div>