<?php

if ( ! class_exists( 'WP_List_Table' ) ) {
    require_once( admin_url('/includes/class-wp-list-table.php') );
}
global $__Expt_BaseController;
$etGroupsList = new Expt_Groups_List();
?>
<div class="wrap bootstrap-et">
    <?php $__Expt_BaseController->plugin_et_header(); ?>
    <div class="px-3 py-2">
        <h2 class="fst-italic mb-3 mt-2"><?php _e( 'Groups', 'experttexting-official' ) ?> - <?php _e( 'ExpertTexting Official', 'experttexting-official' ) ?></h2>
        <?php add_thickbox(); ?>
        <div class="et-admin-btn-group">
            <a name="Add Group" href='<?php esc_attr_e( admin_url("admin.php?page=et_subscribers_group#TB_inline?&width=400&height=130&inlineId=add-group") ) ?>' class="thickbox button"><span class="dashicons dashicons-groups"></span><?php _e( 'Add Group', 'experttexting-official' ) ?></a>
        </div>

        <!-- ADD GROUP MODAL -->
        <div id="add-group" style="display:none;">
            <form action="" class="modal_thickbox" method="post">
                <div class="bootstrap-et">

                    <div class="mb-2 row">
                        <label for="et_name" class="col-sm-3 col-form-label"><?php _e('Group Name', 'experttexting-official'); ?></label>
                        <div class="col-sm-9">
                            <input type="text" class="form-control alphanumericSpecialChar" id="et_name" name="et_name" maxlength="50" placeholder="<?php _e( 'Enter Group Name', 'experttexting-official' ) ?>" required>
                        </div>
                    </div>
                    
                    <input type="submit" class="btn btn-success w-100" name="et_add_group" value="<?php _e('Add', 'experttexting-official'); ?>"/>
                </div>
            </form>
        </div>
        <!-- END OF ADD GROUP MODAL -->

        <!-- EDIT GROUP MODAL -->
        <div id="edit-group" style="display:none;">
            <?php
                
            ?>

            <form action="" class="modal_thickbox" method="post">

                <div class="bootstrap-et">

                    <div class="mb-2 row">
                        <label for="et_group_name" class="col-sm-3 col-form-label"><?php _e('Group Name', 'experttexting-official'); ?></label>
                        <div class="col-sm-9">
                            <input type="text" class="form-control alphanumericSpecialChar" id="et_group_name" name="et_group_name" maxlength="50" placeholder="<?php _e( 'Enter Group Name', 'experttexting-official' ) ?>" required>
                            <input type="hidden" id="et_group_id" name="et_group_id" required>
                        </div>
                    </div>

                    <input type="submit" class="btn btn-success w-100" name="et_edit_group" value="<?php _e('Update', 'experttexting-official'); ?>"/>
                </div>
                
            </form>
        </div>
        <!-- END OF EDIT GROUP MODAL -->


        <form id="groups_search" method="get">
            <input type="hidden" name="page" value="<?php esc_attr_e($_REQUEST['page']) ?>"/>
            <?php
            $etGroupsList->prepare_items();
            $etGroupsList->render();
            $etGroupsList->search_box(__('Search', 'experttexting-official'), 'search_id');
            $etGroupsList->display();
            ?>
        </form>
    </div>
</div>

<?php

class Expt_Groups_List extends WP_List_Table {

    protected $perPage;
    protected $count;
    var $data;

    public $__Expt_BaseController, $__Expt_Notices;

    
    /** Class constructor */
    public function __construct() {

        global $__Expt_BaseController;
        global $__Expt_Notices;

        $this->__Expt_BaseController = $__Expt_BaseController;
        $this->__Expt_Notices = $__Expt_Notices;

        parent::__construct( [
        'singular' => __( 'Group', 'experttexting-official' ), //singular name of the listed records
        'plural' => __( 'Groups', 'experttexting-official' ), //plural name of the listed records
        'ajax' => false //should this table support ajax?
        
        ] );

        $this->data = $this->table_data();
        $this->count = count($this->data);
        $this->perPage = 10;

    }


    /**
     * Prepare the items for the table to process
     *
     * @return Void
     */
    public function prepare_items() {

        /** Process bulk action */
        $this->process_bulk_action();

        $columns = $this->get_columns();
        $hidden = $this->get_hidden_columns();
        $sortable = $this->get_sortable_columns();
        
        $perPage = $this->perPage;
        $currentPage = $this->get_pagenum();
        
        $data = $this->data;
        usort( $data, array( &$this, 'sort_data' ) );
        
        $totalItems = $this->count;
        
        $this->set_pagination_args( array(
            'total_items' => $totalItems,
            'per_page'    => $perPage
        ) );

        $data = array_slice($data,(($currentPage-1)*$perPage),$perPage);
            
        $this->_column_headers = array($columns, $hidden, $sortable);
        $this->items = $data;

    }

    /**
     * Override the parent columns method. Defines the columns to use in your listing table
     *
     * @return Array
     */
    public function get_columns() {

        $columns = array(
            'cb' => '<input type="checkbox" />',
            'ID' => __( 'Group ID', 'experttexting-official' ),
            'name' => __( 'Group Name', 'experttexting-official' ),
            'total_subscribers' => __( 'Total Subscribers', 'experttexting-official' ),
        );

        return $columns;
    }

    /**
     * Define which columns are hidden
     *
     * @return Array
     */
    public function get_hidden_columns() {

        return array(
            // 'ID' => 'ID'
        );
    }

    /**
     * Define the sortable columns
     *
     * @return Array
     */
    public function get_sortable_columns() {

        $s_columns = array (
            'ID' => array('ID', true),
            'name' => array( 'name', false),
            'total_subscribers' => array( 'total_subscribers', false),
        );
        return $s_columns;

    }

    /**
    * Returns an associative array containing the bulk action
    *
    * @return Array
    */
    public function get_bulk_actions() {

        $actions = [
            'bulk-delete' => 'Delete'
        ];
        
        return $actions;
    }


    public function process_bulk_action() {

        global $wpdb;
        $notify = array();

        //Detect when a bulk action is being triggered...
        // Search action
        if (isset($_GET['s'])) {
            $prepare = $wpdb->prepare("SELECT * from `{$wpdb->prefix}et_subscribes_group` WHERE name LIKE %s", '%' . $wpdb->esc_like($_GET['s']) . '%');
            if(!$prepare) {

                if( $wpdb->last_error ) {
                    $this->__Expt_BaseController->save_expt_wpdb_log();
                }
            }
            $this->data  = $this->table_data($prepare);
            $this->count = count($this->data);

        }

        if ( 'delete' === $this->current_action() ) {
        
            $res = \ExptTxt\Expt_Api\Expt_Callbacks\Expt_NewsletterCallbacks::deleteGroup(absint($_GET['ID']));

            if ($res) {
                $this->data  = $this->table_data();
                $this->count = count($this->data);

                $notify = array('result' => 'success', 'message' => __('Group has been removed.', 'experttexting-official'));
            } else {

                $notify = array('result' => 'error', 'message' => __('Something has been wrong while removing this group. Please try again later.', 'experttexting-official'));
            }

        }

        if ( 'deletewithsub' === $this->current_action() && isset($_GET['subs']) && $_GET['subs'] == 'true' ) {
        
            $res = \ExptTxt\Expt_Api\Expt_Callbacks\Expt_NewsletterCallbacks::deleteGroupWithSubscribers(absint($_GET['delID']));

            if ($res) {
                $this->data  = $this->table_data();
                $this->count = count($this->data);

                $notify = array('result' => 'success', 'message' => __('Group including subscribers has been removed.', 'experttexting-official'));
            } else {

                $notify = array('result' => 'error', 'message' => __('Something has been wrong while removing this group including subscribers. Please try again later.', 'experttexting-official'));
            }

        }
        
        // If the delete bulk action is triggered
        if ('bulk-delete' == $this->current_action() ) {
            if(isset($_GET['bulk-delete'])) {

                $bulk_delete = $this->__Expt_BaseController->expt_sanitize_array_data( $_GET['bulk-delete'] );
                
                foreach ($bulk_delete as $id) {
                    $res = \ExptTxt\Expt_Api\Expt_Callbacks\Expt_NewsletterCallbacks::deleteGroup(absint($id));
                }
                
                if($res) {
                    $this->data  = $this->table_data();
                    $this->count = count($this->data);
                    
                    $notify = array('result' => 'success', 'message' => __('Group(s) has been removed.', 'experttexting-official'));
                } else {
                    
                    $notify = array('result' => 'error', 'message' => __('Unable to remove group(s). Please try again or contact ExpertTexting support if issue persists.', 'experttexting-official'));
                }
                
            } else {

                $notify = array('result' => 'error', 'message' => __('No group selected.', 'experttexting-official'));
            }
        }

        if (isset($notify['message'])) {
            $this->__Expt_Notices->notice( esc_attr($notify['message']), esc_attr($notify['result']) );
        }

    }


    /**
    * Render the bulk edit checkbox
    *
    * @param array $item
    *
    * @return string
    */
    function column_cb( $item ) {
        
        return sprintf(
        '<input type="checkbox" name="bulk-delete[]" value="%s" />', absint($item['ID'])
        );

    }

    /**
    * Returns the count of records in the database.
    *
    * @return null|string
    */
    public static function record_count() {
        global $wpdb;
        
        $sql = "SELECT COUNT(*) FROM {$wpdb->prefix}et_subscribes_group";
        
        return $wpdb->get_var( $sql );
    }

    /** Text displayed when no subscriber data is available */
    public function no_items() {
        esc_attr_e( 'No groups available.', 'experttexting-official' );
    }


    /**
    * Retrieve subscriber’s data from the database
    *
    * @return mixed
    */
    
    // Table Data

    public function table_data( $sql = '' )
    {
        $data = array();        

        global $wpdb;

        if ( !$sql ) {
            $sql = "SELECT * FROM {$wpdb->prefix}et_subscribes_group";
        }

        $wpdb->show_errors();

        $result = $wpdb->get_results( $sql );

        if(!$result) {

            if( $wpdb->last_error ) {
                $this->__Expt_BaseController->save_expt_wpdb_log();
            }
        }

        // loop over the array of record IDs
        foreach ( $result as $record ) {

            $data[] = array(
                'ID' => $record->{"ID"},
                'name' => $record->{"name"},
                'total_subscribers' => $record->{"ID"},
            );
        }

        return $data;
    }


    /**
     * Define what data to show on each column of the table
     *
     * @param  Array $item        Data
     * @param  String $column_name - Current column name
     *
     * @return Mixed
     */
    public function column_default( $item, $column_name )
    {
        switch( $column_name ) {
            
            case 'ID':
            case 'name':
                return $item[ $column_name ];
            case 'total_subscribers':
                $res = \ExptTxt\Expt_Api\Expt_Callbacks\Expt_NewsletterCallbacks::getSubsGroupCount($item[ $column_name ]);
                return $res;

            default:
                return print_r( $item, true ) ;
        }
    }


    /**
    * Method for name column
    *
    * @param array $item an array of DB data
    *
    * @return string
    */
    
    function column_name( $item )
    {
        //Build row actions
        add_thickbox();
        $actions = array(
            'edit'   => sprintf('<a name="Edit Group" class="thickbox" href="?page=et_subscribers_group#TB_inline?&width=400&height=130&inlineId=edit-group" onclick="edit_group_params( %d,\'%s\' )">' . __('Edit', 'experttexting-official') . '</a>', absint( $item['ID'] ), $item['name']),
            'delete' => sprintf('<a href="?page=%s&action=%s&ID=%s" onclick="con = confirm(\'' . __('Are you sure you want to delete this group?', 'experttexting-official') .'\r\n\r\n'. __('Note: This action cannot be undone.', 'experttexting-official') . '\'); if(con != true){return false;}">' . __('Delete', 'experttexting-official') . '</a>', esc_attr( $_REQUEST['page'] ), 'delete', absint( $item['ID'] )),
            'deleteWithSub' => sprintf('<a href="?page=%s&action=%s&delID=%s&subs=true" onclick="con = confirm(\'' . __('Are you sure you want to delete this group including all subscribers in this group?', 'experttexting-official') .'\r\n\r\n'. __('Note: This action cannot be undone.', 'experttexting-official') . '\'); if(con != true){return false;}">' . __('Delete with Subscribers', 'experttexting-official') . '</a>', esc_attr( $_REQUEST['page'] ), 'deletewithsub', absint( $item['ID'] )),
        );

        //Return the title contents
        return sprintf(
            '%1$s %3$s',
            $item['name'],
            absint($item['ID']),
            $this->row_actions($actions)
        );
    }
    

    /**
     * Allows you to sort the data by the variables set in the $_REQUEST
     *
     * @return Mixed
     */
    private function sort_data( $a, $b ) {

        // Set defaults
        $def_orderby = 'ID';
        $def_order = 'desc';

        $orderby = ( !empty( $_REQUEST['orderby'] ) ) ? sanitize_text_field( $_REQUEST['orderby'] ) : $def_orderby;
        $order = ( !empty( $_REQUEST['order'] ) ) ? sanitize_text_field( $_REQUEST['order'] ) : $def_order;
        $result = strnatcmp( $a[$orderby], $b[$orderby] );

        return ( $order==='asc' ) ? $result : -$result;
    }


    /**
     * Renders some Actions
     * 
     */
    public function render() {

        // Add Group
        if (isset($_POST['et_add_group'])) {

            $result = \ExptTxt\Expt_Api\Expt_Callbacks\Expt_NewsletterCallbacks::addGroup( sanitize_text_field( $_POST['et_name'] ) );

            $this->data  = $this->table_data();
            $this->count = count($this->data);
            self::prepare_items();
            
            if(isset($result['message'])) {
                $this->__Expt_Notices->notice( esc_attr($result['message']), esc_attr($result['result']) );
            }
        }

        ?>

        <script>
        // Edit Group JS
        function edit_group_params( group_id = null, group_name = null ) {
            
            if ( group_id != null && group_name != null ) {
                jQuery("#et_group_id").val(group_id);
                jQuery("#et_group_name").val(group_name);
            }

        }
        </script>

        <?php
        // Edit Group
        if (isset($_POST['et_edit_group'])) {

            $result = \ExptTxt\Expt_Api\Expt_Callbacks\Expt_NewsletterCallbacks::updateGroup( sanitize_text_field( $_POST['et_group_id'] ), sanitize_text_field( $_POST['et_group_name'] ) );

            $this->data  = $this->table_data();
            $this->count = count($this->data);
            self::prepare_items();
            
            if(isset($result['message'])) {
                $this->__Expt_Notices->notice( esc_attr($result['message']), esc_attr($result['result']) );
            }
        }
        
    }
    
}


