<script type="text/javascript">
    jQuery(document).ready(function ($) {
        $("#et_send_subscribe").change(function () {
            if (this.value == 'yes') {
                $('#et_select_group_container').slideDown();
                $('#et_message_body_container').slideDown();
            } else {
                $('#et_select_group_container').slideUp();
                $('#et_message_body_container').slideUp();
            }
        });
    })
</script>

<table class="form-table bootstrap-et">
    <tr valign="top">
        <th scope="row">
            <label for="et_send_subscribe"><?php _e('Send this post to subscribers?', 'experttexting-official'); ?>:</label>
        </th>
        <td>
            <select class="regular-text" name="et_send_subscribe" id="et_send_subscribe">
                <option value="yes" selected><?php _e( 'Yes', 'experttexting-official' ) ?></option>
                <option value="no"><?php _e( 'No', 'experttexting-official' ) ?></option>
            </select>
        </td>
    </tr>
    <tr valign="top" id="et_select_group_container">
        <th scope="row">
            <label for="et_subscribe_group"><?php _e('Select Group', 'experttexting-official'); ?>:</label>
        </th>
        <td>
            <select class="regular-text" name="et_subscribe_group" id="et_subscribe_group">
                <option value="all"><?php _e( sprintf(__('All (%s Subscribers Active)', 'experttexting-official'), $subscribers) ); ?></option>
                <?php foreach ($groups as $items): ?>
                    <?php
                    $itemID = esc_attr( $items->ID );
                    $groupId  = $wpdb->query("SELECT * FROM {$wpdb->prefix}et_subscribes WHERE group_ID = {$itemID} AND status = 1");
                    if(!$groupId) {
                        if( $wpdb->last_error ) {
                            $__Expt_BaseController->save_expt_wpdb_log();
                        }
                    }
                    ?>
                    <option value="<?php esc_attr_e( absint($items->ID) ); ?>"><?php esc_attr_e( sprintf('%s (%s Subscribers Active)', $items->name, $groupId) ); ?></option>
                <?php endforeach; ?>
            </select>
        </td>
    </tr>
    <tr valign="top" id="et_message_body_container">
        <th scope="row">
            <label for="et_message_body"><?php _e('Message Template', 'experttexting-official'); ?>:</label>
        </th>
        <td>
            <textarea class="regular-text" rows="5" id="et_message_body" name="et_message_body"><?php esc_attr_e( get_option( 'et_notifications' )['on_new_post_body'] ); ?></textarea>
            <br>
            <span class="fw-normal  text-muted">
                <?php _e( 'Enter the contents of the sms message.', 'experttexting-official' ) ?>
                <br><br>
                <ul style="font-style: normal !important">
                    <li><strong>Post title:</strong> <mark>[post_title]</mark></li>
                    <li><strong>Post content:</strong> <mark>[post_content]</mark></li>
                    <li><strong>Post url:</strong> <mark>[post_url]</mark></li>
                    <li><strong>Post date:</strong> <mark>[post_date]</mark></li>
                </ul>
            </span>
        </td>
    </tr>
</table>