<?php

if ( ! class_exists( 'WP_List_Table' ) ) {
    require_once( admin_url('/includes/class-wp-list-table.php') );
}
global $__Expt_BaseController;
$etOutboxList = new Expt_Outbox_List();
?>
<div class="wrap bootstrap-et">
    <?php $__Expt_BaseController->plugin_et_header(); ?>
    <div class="px-3 py-2">
        <h2 class="fst-italic mb-3 mt-2"><?php _e( 'Outbox', 'experttexting-official' ) ?> - <?php _e( 'ExpertTexting Official', 'experttexting-official' ) ?></h2>

        <?php if (isset($_GET['sendmsgID'])) { ?>
            <div class="et-admin-btn-group">
                <a name="All Messages" href='<?php esc_attr_e( admin_url("admin.php?page=et_subscribers_outbox") ) ?>' class="button"><span class="dashicons dashicons-format-chat"></span><?php _e( 'View All Messages', 'experttexting-official' ) ?></a>
            </div>
        <?php } ?>

        <form id="groups_search" method="get">
            <input type="hidden" name="page" value="<?php esc_attr_e( $_REQUEST['page'] ) ?>"/>
            <?php
            $etOutboxList->prepare_items();
            $etOutboxList->search_box(__('Search', 'experttexting-official'), 'search_id');
            $etOutboxList->display();
            ?>
        </form>
    </div>
</div>

<?php

class Expt_Outbox_List extends WP_List_Table {

    protected $perPage;
    protected $count;
    var $data;

    public $__Expt_BaseController, $__Expt_Notices, $__Expt_ApiCallbacks;

    /** Class constructor */
    public function __construct() {

        global $__Expt_BaseController, $__Expt_Notices, $__Expt_ApiCallbacks;

        $this->__Expt_BaseController = $__Expt_BaseController;
        $this->__Expt_Notices = $__Expt_Notices;
        $this->__Expt_ApiCallbacks = $__Expt_ApiCallbacks;

        parent::__construct( [
        'singular' => __( 'Outbox', 'experttexting-official' ), //singular name of the listed records
        'plural' => __( 'Outboxes', 'experttexting-official' ), //plural name of the listed records
        'ajax' => false //should this table support ajax?
        
        ] );

        $this->outboxChkStatus();

        $this->data = $this->table_data();
        $this->count = count($this->data);
        $this->perPage = 10;
    }

    /**
     * Checked the status of the message whether the message was sent or not.
     * 
     * @since 1.2.0
     */
    public function outboxChkStatus() {

        global $wpdb;
        $result = $wpdb->get_results("SELECT `ID`, `messages_id` FROM `{$wpdb->prefix}et_send` WHERE `messages_id` != ''");

        if($result) {

            $username = $this->__Expt_BaseController->apiUsername;
            $apikey = $this->__Expt_BaseController->apikey;
            $apisecret = $this->__Expt_BaseController->apisecret;

            if ( !$this->__Expt_BaseController->apiValues || ( !$this->__Expt_BaseController->apiUsername && !$this->__Expt_BaseController->apikey && !$this->__Expt_BaseController->apisecret ) ) return;

            $msgResponse = array();

            foreach( $result as $res ) {

                $outbox_id = $res->{"ID"};
                $messages_id = $res->{"messages_id"};
                $unserialize_messages_id = unserialize($messages_id);
                $success = 0;
                $failed = 0;

                if( !count($unserialize_messages_id) ) {

                    $wpdb->update(
                        $wpdb->prefix . "et_send",
                        array(
                            'messages_id' => '',
                        ),
                        array(
                            'ID' => esc_attr( $outbox_id )
                        )
                    );

                    return;
                }

                foreach( $unserialize_messages_id as $unserial_msg ) {

                    $msgNumber = $unserial_msg[0];
                    $msgID = $unserial_msg[1];

                    $this->__Expt_ApiCallbacks->username = $username;
                    $this->__Expt_ApiCallbacks->apikey = $apikey;
                    $this->__Expt_ApiCallbacks->apisecret = $apisecret;
    
                    $this->__Expt_ApiCallbacks->messageId = $msgID;
                    $result = $this->__Expt_ApiCallbacks->msgStatus();

                    if ( is_wp_error( $result ) ) {
                        $res = $result;
                    } else {
                        $res = json_decode($result, true);
                    }

                    if (gettype($res) == "array" && !is_wp_error( $res ) ) {

                        if ($res["Status"] == 0) {

                            $msgResponse[$msgNumber] = esc_attr( $res["Response"]["Status"] );

                            if( $res["Response"]["Status"] !== "SENT") {
                                $msgStatus = esc_attr( $res["Response"]["Status"] );
                                $failed++;
                            } else {
                                $success++;
                            }
                            
                        }

                    }

                }
                
                $msgResponseStr = '';
                foreach($msgResponse as $key => $val) {
                    $msgResponseStr .= $key . ': ' . $val . ', ';
                }

                $wpdb->update(
                    $wpdb->prefix . "et_send",
                    array(
                        'response' => esc_attr($msgResponseStr),
                        'status' => (!empty($msgStatus) ? esc_attr($msgStatus) : "Successful"),
                        'messages_id' => (!empty($msgStatus) && $msgStatus == 'PENDING') ? $messages_id : '',
                        'success' => esc_attr($success),
                        'failed' => esc_attr($failed),
                    ),
                    array(
                        'ID' => esc_attr( $outbox_id )
                    )
                );

            }

        } else {

            if( $wpdb->last_error ) {
                $this->__Expt_BaseController->save_expt_wpdb_log();
            }

        }

    }


    /**
     * Prepare the items for the table to process
     *
     * @return Void
     */
    public function prepare_items() {

        /** Process bulk action */
        $this->process_bulk_action();

        $columns = $this->get_columns();
        $hidden = $this->get_hidden_columns();
        $sortable = $this->get_sortable_columns();

        $perPage = $this->perPage;
        $currentPage = $this->get_pagenum();
        
        $data = $this->data;
        usort( $data, array( $this, 'sort_data' ) );
        
        $totalItems = $this->count;
        
        $this->set_pagination_args( array(
            'total_items' => $totalItems,
            'per_page'    => $perPage
            ) );

        $data = array_slice($data,(($currentPage-1)*$perPage),$perPage);
            
        $this->_column_headers = array($columns, $hidden, $sortable);
        $this->items = $data;

    }

    /**
     * Override the parent columns method. Defines the columns to use in your listing table
     *
     * @return Array
     */
    public function get_columns() {

        $columns = array(
            'cb' => '<input type="checkbox" />',
            'ID' => __( 'ID', 'experttexting-official' ),
            'sender' => __( 'Sender', 'experttexting-official' ),
            'date' => __( 'Date', 'experttexting-official' ),
            'message' => __( 'Message', 'experttexting-official' ),
            'recipient' => __( 'Recipient', 'experttexting-official' ),
            'response' => __( 'Response', 'experttexting-official' ),
            'status' => __( 'Status', 'experttexting-official' ),
            'message_count' => __( 'Message Count', 'experttexting-official' ),
            'success' => __( 'Success', 'experttexting-official' ),
            'failed' => __( 'Failed', 'experttexting-official' ),
        );

        return $columns;
    }

    /**
     * Define which columns are hidden
     *
     * @return Array
     */
    public function get_hidden_columns() {

        return array(
            'ID' => 'ID'
        );
    }

    /**
     * Define the sortable columns
     *
     * @return Array
     */
    public function get_sortable_columns() {

        $s_columns = array (
            'ID' => array('ID', false),
            'sender' => array( 'sender', false),
            'date' => array( 'date', true),
            'success' => array( 'success', false),
            'failed' => array( 'failed', false),
        );
        return $s_columns;

    }

    /**
    * Returns an associative array containing the bulk action
    *
    * @return Array
    */
    public function get_bulk_actions() {

        $actions = [
            'bulk-delete' => 'Delete'
        ];
        
        return $actions;
    }


    public function process_bulk_action() {

        global $wpdb;
        $notify = array();

        //Detect when a bulk action is being triggered...
        // Search action
        if (isset($_GET['s'])) {
            $prepare     = $wpdb->prepare("SELECT * from `{$wpdb->prefix}et_send` WHERE sender LIKE %s OR message LIKE %s OR recipient LIKE %s ", '%' . $wpdb->esc_like($_GET['s']) . '%', '%' . $wpdb->esc_like($_GET['s']) . '%', '%' . $wpdb->esc_like($_GET['s']) . '%');
            if(!$prepare) {

                if( $wpdb->last_error ) {
                    $this->__Expt_BaseController->save_expt_wpdb_log();
                }
            }
            $this->data  = $this->table_data($prepare);
            $this->count = count($this->data);
        }

        if (isset($_GET['sendmsgID'])) {
            $prepare     = $wpdb->prepare("SELECT * from `{$wpdb->prefix}et_send` WHERE ID LIKE %s", '%' . $wpdb->esc_like($_GET['sendmsgID']) . '%');
            if(!$prepare) {

                if( $wpdb->last_error ) {
                    $this->__Expt_BaseController->save_expt_wpdb_log();
                }
            }
            $this->data  = $this->table_data($prepare);
            $this->count = count($this->data);
        }

        if ( 'delete' === $this->current_action() ) {
        
            if(isset($_GET['message'])) {
                
                $res = $wpdb->delete($wpdb->prefix . "et_send", array('ID' => absint($_GET['message'])));
                if ($res) {
                    $this->data  = $this->table_data();
                    $this->count = count($this->data);
                    
                    $notify = array('result' => 'success', 'message' => __('Message removed.', 'experttexting-official'));
                }
            }

        }
        
        // If the delete bulk action is triggered
        if ('bulk-delete' == $this->current_action() ) {

            if(isset($_GET['bulk-delete'])) {

                $bulk_delete = $this->__Expt_BaseController->expt_sanitize_array_data( $_GET['bulk-delete'] );

                foreach ($bulk_delete as $id) {
                    $res = self::delete_message($id);
                }

                if($res) {

                    $this->data  = $this->table_data();
                    $this->count = count($this->data);
                    $notify = array('result' => 'success', 'message' => __('Messages removed.', 'experttexting-official'));
                } else {
                    
                    $notify = array('result' => 'error', 'message' => __('Unable to remove message(s). Please try again or contact ExpertTexting support if issue persists.', 'experttexting-official'));
                }

            } else {

                $notify = array('result' => 'error', 'message' => __('No message selected.', 'experttexting-official'));
            }
        }

        // If the delete bulk action is triggered
        if ('resend' == $this->current_action() ) {
            
            if( isset($_GET['message']) ) {
                
                self::resendMsg(absint($_GET['message']));
    
                $this->data  = $this->table_data();
                $this->count = count($this->data);
            }

        }

        if (isset($notify['message'])) {
            $this->__Expt_Notices->notice( esc_attr( $notify['message'] ), esc_attr( $notify['result'] ) );
        }

    }


    /**
    * Delete a message record.
    *
    * @param int $id message ID
    */
    public static function delete_message( $id ) {
        global $wpdb, $__Expt_BaseController;
        
        $result = $wpdb->delete(
        "{$wpdb->prefix}et_send",
        [ 'ID' => $id ],
        [ '%d' ]
        );

        if($result) {
            if( $wpdb->last_error ) {
                $__Expt_BaseController->save_expt_wpdb_log();
            }
        }

        return array('result' => 'success', 'message' => __('Message removed.', 'experttexting-official'));

    }


    /**
    * Render the bulk edit checkbox
    *
    * @param array $item
    *
    * @return string
    */
    function column_cb( $item ) {
        
        return sprintf(
        '<input type="checkbox" name="bulk-delete[]" value="%s" />', absint($item['ID'])
        );

    }

    /**
    * Returns the count of records in the database.
    *
    * @return null|string
    */
    public static function record_count() {
        global $wpdb;
        
        $sql = "SELECT COUNT(*) FROM {$wpdb->prefix}et_send";
        
        return $wpdb->get_var( $sql );
    }

    /** Text displayed when no subscriber data is available */
    public function no_items() {
        _e( 'No messages available.', 'experttexting-official' );
    }


    /**
    * Retrieve messages’ data from the database
    *
    * @return mixed
    */
    
    // Table Data

    public function table_data( $sql = '' )
    {
        $data = array();        

        global $wpdb;

        if ( !$sql ) {
            $sql = "SELECT * FROM {$wpdb->prefix}et_send";
        }

        $wpdb->show_errors();

        $result = $wpdb->get_results( $sql );

        if(!$result) {

            if( $wpdb->last_error ) {
                $this->__Expt_BaseController->save_expt_wpdb_log();
            }
        }

        // loop over the array of record IDs
        foreach ( $result as $record ) {

            $data[] = array(
                'ID' => $record->{"ID"},
                'sender' => $record->{"sender"},
                'date' => $record->{"date"},
                'message' => $record->{"message"},
                'recipient' => $record->{"recipient"},
                'response' => $record->{"response"},
                'status' => $record->{"status"},
                'message_count' => $record->{"message_count"},
                'success' => $record->{"success"},
                'failed' => $record->{"failed"},
            );
        }

        return $data;
    }


    /**
     * Define what data to show on each column of the table
     *
     * @param  Array $item Data
     * @param  String $column_name Current column name
     *
     * @return Mixed
     */
    public function column_default( $item, $column_name )
    {
        $str = '';
        switch( $column_name ) {
            
            case 'ID':
            case 'sender':
                return $this->column_name($item);
            case 'date':
                return sprintf(__('%s <span class="et_time">%s</span>'), date_i18n('Y-m-d', strtotime($item[$column_name])), date_i18n('H:i', strtotime($item[$column_name])));
            case 'message':
                return $item[ $column_name ];
            case 'recipient':
                return '<details><summary>' . __('View all Recipients', 'experttexting-official') . '</summary><br><p>' . $item[ $column_name ] . '</p></details>';
            case 'response':
                if ( 'All Sent' != $item[ $column_name ] ) {
                    $str .= '<details><summary>' . __('View all Responses', 'experttexting-official') . '</summary><br><ul class="p-0">';
                    $resArr = explode(",", $item[ $column_name ]);
                    $resArr = array_filter($resArr);
                    for ( $i=0; $i<count($resArr)-1; $i++ ) {
                        $temp = explode(": ", $resArr[$i] );
                        $str .= '<li>'. '<b>' . $temp[0] . ':</b> ' . $temp[1] .'</li>';
                    }
                    $str .= '</ul></details>';
                } else {
                    $str = '<span class="text-success">'. $item[ $column_name ] .'</span>';
                }
                return  $str;

            case 'status':
                return $item[ $column_name ];

            case 'message_count':
                return $item[ $column_name ] ? $item[ $column_name ] : '-';

            case 'success':
                return '<span class="bg-success p-1 px-2 rounded text-white">' . $item[ $column_name ] .  '</span>';

            case 'failed':
                return '<span class="bg-danger p-1 px-2 rounded text-white">' . $item[ $column_name ] .  '</span>';

            default:
                return print_r( $item, true ) ;
        }
    }
    

    /**
    * Method for sender column
    *
    * @param array $item an array of DB data
    *
    * @return string
    */
    function column_name( $item ) {
       
        $title = $item['sender'];
        
        $actions = [
            'resend' => sprintf( '<a href="?page=%s&action=%s&message=%s" onclick="con = confirm(\'' . __('Are you sure you want to resend this message?', 'experttexting-official') . '\'); if(con != true){return false;} et_loader(\'.wrap.bootstrap-et\', \'<h5 class=text-center >' . __('Message sending in progress. <br>Please wait!', 'experttexting-official') . '</h5>\', \'true\')">' . __('Resend', 'experttexting-official') . '</a>', esc_attr( $_REQUEST['page'] ), 'resend', absint( $item['ID'] )),
            'delete' => sprintf( '<a href="?page=%s&action=%s&message=%s" onclick="con = confirm(\'' . __('Are you sure you want to delete this message?', 'experttexting-official') .'\r\n\r\n'. __('Note: This action cannot be undone.', 'experttexting-official') . '\'); if(con != true){return false;}">' . __('Delete', 'experttexting-official') . '</a>', esc_attr( $_REQUEST['page'] ), 'delete', absint( $item['ID'] ))
        ];
        
        return $title . $this->row_actions( $actions );
    }


    /**
     * Allows you to sort the data by the variables set in the $_REQUEST
     *
     * @return Mixed
     */
    private function sort_data( $a, $b ) {

        // Set defaults
        $def_orderby = 'date';
        $def_order = 'desc';

        $orderby = ( !empty( $_REQUEST['orderby'] ) ) ? sanitize_text_field( $_REQUEST['orderby'] ) : $def_orderby;
        $order = ( !empty( $_REQUEST['order'] ) ) ? sanitize_text_field( $_REQUEST['order'] ) : $def_order;
        $result = strnatcmp( $a[$orderby], $b[$orderby] );

        return ( $order==='asc' ) ? $result : -$result;
    }


    /**
     * Renders some Actions
     * 
     */
    public static function resendMsg($id) {

        global $__Expt_BaseController, $__Expt_ApiCallbacks;

        // Resend Message
        if ($id != "" && !empty($id)) {

            $messageID = $id;

            global $wpdb;

            $query = "SELECT * FROM {$wpdb->prefix}et_send WHERE ID = {$messageID}";
            $wpdb->show_errors();

            $result = $wpdb->get_results( $query );

            if(!$result) {

                if( $wpdb->last_error ) {
                    $__Expt_BaseController->save_expt_wpdb_log();
                }
            }

            // Record of get ID
            foreach ( $result as $record ) {

                $data[] = array(
                    'et_send_from' => $record->{"sender"},
                    'et_send_to' => explode(', ', $record->{"recipient"}),
                    'et_send_msg' => $record->{"message"},
                    'et_send_check_unicode' => $record->{"message_type"} == "text" ? "false" : "true",
                );

                update_option( "resend_msg_request", $record->{"ID"}, "yes" );

            }

            update_option( "et_send_sms", $data[0], "yes" );

            $res = $__Expt_ApiCallbacks->sendMessage();

            if( $res ) {
                $__Expt_BaseController->save_expt_log( $res, $data[0] );
            }

        }
        
    }
    
}


