<?php 

global $__Expt_BaseController, $__Expt_Notices;

$subpage = isset( $_GET['sub'] ) ? sanitize_text_field( $_GET['sub'] ) : 'general';

?>

<div id="et_admin" class="wrap bootstrap-et">

    <?php $__Expt_BaseController->plugin_et_header(); ?>

    <?php 
    if( count( get_settings_errors() ) > 0 ) {
        $gettype = get_settings_errors()[0]["type"];
        $getmessage = get_settings_errors()[0]["message"];
        $__Expt_Notices->notice( $getmessage, $gettype );
    }
    if( $__Expt_BaseController->activated( 'et_general_set', 'et_general_log_chk' ) ) {
        $__Expt_Notices->notice( __('ExpertTexting logging is currently enabled. Since logs may contain sensitive information, please ensure that you only leave it enabled for as long as it is needed for troubleshooting.', 'experttexting-official') . ' <br> ' . __('Once troubleshooting is complete, disable logging and/or permanently delete your log files by', 'experttexting-official') . ' <a href="'. esc_attr( admin_url("admin.php?page=et_settings&sub=logging") ) .'">' . __('clicking here') . '</a>', 'warning' );
    }
    ?>

    <div class="px-3 py-2 et_settings_section">
        <h2 class="m-0 p-0"></h2>
        <div class="container-fluid mt-2">
            <div class="row">
                <div class="col-md-3 pe-md-2 py-md-3 pt-3 pb-2">
                    <div class="card col py-4">
                        <div class="nav nav-pills flex-column" id="nav-tab" role="tablist" aria-orientation="vertical">
                            <li class="text-center">
                                <span class="border-bottom d-block h5 text-dark p-2"><?php esc_attr_e( 'SETTINGS', 'experttexting-official' ) ?></span>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link etmenu <?php $subpage === 'general' ? _e('active') : ''; ?>" href='<?php esc_attr_e( admin_url("admin.php?page=et_settings&sub=general") )?>' ><img class="et_menu_icon" src="<?php _e( ($__Expt_BaseController->plugin_url . "assets/img/icon_general.png") ); ?>" alt="icon_general"><?php _e( 'General Settings', 'experttexting-official' ) ?></a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link etmenu <?php $subpage === 'api' ? _e('active') : ''; ?>" href='<?php esc_attr_e( admin_url("admin.php?page=et_settings&sub=api") )?>' ><img class="et_menu_icon" src="<?php _e( ($__Expt_BaseController->plugin_url . "assets/img/icon_api.png") ); ?>" alt="icon_api"><?php _e( 'API Configuration', 'experttexting-official' ) ?></a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link etmenu <?php $subpage === 'manage' ? _e('active') : ''; ?>" href='<?php esc_attr_e( admin_url("admin.php?page=et_settings&sub=manage") )?>' ><img class="et_menu_icon" src="<?php _e( ($__Expt_BaseController->plugin_url . "assets/img/icon_features.png") ); ?>" alt="icon_features"><?php _e( 'Manage Features', 'experttexting-official' ) ?></a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link etmenu <?php $subpage === 'newsletter' ? _e('active') : ''; ?>" href='<?php esc_attr_e( admin_url("admin.php?page=et_settings&sub=newsletter") )?>' ><img class="et_menu_icon" src="<?php _e( ($__Expt_BaseController->plugin_url . "assets/img/icon_newsletter.png") ); ?>" alt="icon_newsletter"><?php _e( 'SMS Newsletter', 'experttexting-official' ) ?></a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link etmenu <?php $subpage === 'notifications' ? _e('active') : ''; ?>" href='<?php esc_attr_e( admin_url("admin.php?page=et_settings&sub=notifications") )?>' ><img class="et_menu_icon" src="<?php _e( ($__Expt_BaseController->plugin_url . "assets/img/icon_notifications.png") ); ?>" alt="icon_notifications"><?php _e( 'Manage Notifications', 'experttexting-official' ) ?></a>
                            </li>
                            <?php if( $__Expt_BaseController->activated( 'et_general_set', 'et_general_log_chk' ) ) { ?>
                            <li class="nav-item">
                                <a class="nav-link etmenu <?php $subpage === 'logging' ? _e('active') : ''; ?>" href='<?php esc_attr_e( admin_url("admin.php?page=et_settings&sub=logging") )?>' ><img class="et_menu_icon" src="<?php _e( ($__Expt_BaseController->plugin_url . "assets/img/icon_log.png") ); ?>" alt="icon_log"><?php _e( 'ExpertTexting Logs', 'experttexting-official' ) ?></a>
                            </li>
                            <?php } ?>
                        </div>
                    </div>
                </div>
                
                <div class="col-md-9 ps-md-2 py-md-3 pb-3 pt-2">
                    <div class="card col py-4">
                        <?php if ($subpage == 'general' || $subpage == '') { ?>
                            <!-- General Settings Page -->
                            <form method="post" action="options.php" class="et-send-sms-form">
                                <?php
                                settings_fields( 'et_plugin_general_settings' );
                                do_settings_sections( 'et_general_settings' );
                                submit_button();
                                ?>
                            </form>

                        <?php } elseif ($subpage == 'api') { ?>
                            <!-- API Settings Page -->
                            <form method="post" action="options.php" class="et-send-sms-form">
                                <?php
                                settings_fields( 'et_plugin_api_settings' );
                                do_settings_sections( 'et_api_settings' );
                                _e( '<input type="hidden" class="regular-text" name="etApiAuthHidden" value="authCheck">' );
                                submit_button();
                                ?>
                            </form>
                        <?php } elseif ($subpage == 'manage') { ?>
                            <!-- Manage Settings Page -->
                            <form method="post" action="options.php" class="et-send-sms-form">
                                <?php
                                settings_fields( 'et_plugin_settings' );
                                do_settings_sections( 'et_menu' );
                                submit_button();
                                ?>
                            </form>

                        <?php } elseif ($subpage == 'newsletter') { ?>
                            <!-- Newsletter Settings Page -->
                            <form method="post" action="options.php" class="et-send-sms-form">
                                <?php
                                settings_fields( 'et_plugin_newsletter_settings' );
                                do_settings_sections( 'et_newsletter_settings' );
                                submit_button();
                                ?>
                            </form>

                        <?php } elseif ($subpage == 'notifications') { ?>
                            <!-- Notifications Settings Page -->
                            <form method="post" action="options.php" class="et-send-sms-form">
                                <?php
                                settings_fields( 'et_plugin_notifications_settings' );
                                do_settings_sections( 'et_notifications_settings' );
                                submit_button();
                                ?>
                            </form>

                        <?php } elseif ($subpage == 'logging' && $__Expt_BaseController->activated( 'et_general_set', 'et_general_log_chk' )) { ?>
                            <!-- Logging Settings Page -->
                            <h2><?php _e( 'ExpertTexting Log Files', 'experttexting-official' ) ?></h2>
                            <?php _e( 'Download log files of ExpertTexting Plugin', 'experttexting-official' ) ?>

                            <table class="form-table table table-bordered mt-4" role="presentation">
                                <thead>
                                    <tr>
                                        <th scope="col"><?php _e( '#' ) ?></th>
                                        <th scope="col"><?php _e( 'Name', 'experttexting-official' ) ?></th>
                                        <th scope="col"><?php _e( 'Action', 'experttexting-official' ) ?></th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <?php
                                        global $wpdb;
                                        $prepare = $wpdb->prepare("SELECT option_name, option_value from `{$wpdb->prefix}options` WHERE option_name LIKE %s ORDER BY option_name DESC", '%expttxt_log_%');
                                        $result = $wpdb->get_results( $prepare );
                                        $i = 1;

                                        if( !$result ) {
                                            ?>
                                                <tr>
                                                    <td scope="row" colspan=3 class="col-12">
                                                        <h6 class="m-0 fw-normal text-center"><?php _e( 'No log file available', 'experttexting-official' ) ?></h6>
                                                    </td>
                                                </tr>
                                            <?php
                                        }

                                        foreach ( $result as $record ) {
                                            ?>
                                                <tr>
                                                    <td scope="row" class="col-1">
                                                        <h6 class="m-0 fw-normal"><?php esc_attr_e( ($i.'.') ) ?></h6>
                                                    </td>
                                                    <td class="col-7">
                                                        <h6 class="m-0 fw-normal"><?php esc_attr_e( $record->{'option_name'} ); ?> <b class="small">(<?php esc_attr_e( $__Expt_BaseController->checkFiles( $record->{'option_value'} ) ) ?>)</b></h6>
                                                    </td>
                                                    <td class="col-3">
                                                        <?php
                                                            $strsplit = explode( "_expt_error_log_file.log" , esc_attr( $record->{'option_value'} ) );
                                                            $strtimeFILE = strtotime( $strsplit[0] );
                                                            $generatedURL = add_query_arg( '_wpnonce', wp_create_nonce( 'log-' . $strtimeFILE ), esc_attr( admin_url(sprintf("admin.php?page=et_settings&sub=logging&log_download=%s", $strtimeFILE)) ) );
                                                        ?>
                                                        <?php
                                                            $strsplit2 = explode( "_expt_error_log_file.log" , esc_attr( $record->{'option_value'} ) );
                                                            $strtimeFILE2 = strtotime( $strsplit2[0] );
                                                            $generatedURL2 = add_query_arg( '_wpnonce', wp_create_nonce( 'delete-' . $strtimeFILE2 ), esc_attr( admin_url(sprintf("admin.php?page=et_settings&sub=logging&log_download=%s&del=%s", $strtimeFILE2, ('012' . $strtimeFILE2 . '210'))) ) );
                                                        ?>
                                                        <div class="d-flex justify-content-between">
                                                            <h6 class="m-0 fw-normal"><a class="btn btn-success btn-sm text-white" href="<?php _e( $generatedURL ); ?>"><?php _e( 'Download Log File', 'experttexting-official' ); ?></a></h6>
                                                            <h6 class="m-0 fw-normal"><a class="btn btn-danger btn-sm text-white" href="<?php _e( $generatedURL2 ); ?>"><?php _e( 'Delete', 'experttexting-official' ); ?></a></h6>
                                                        </div>
                                                    </td>
                                                </tr>
                                            <?php 
                                            $i++; 
                                        }
                                    ?>
                                </tbody>
                            </table>

                        <?php } else {
                            header('location: ' . admin_url("admin.php?page=et_settings"));
                        } ?>

                    </div>
                </div>
            </div>
        </div>

    <div>

</div>

<?php

if(isset($_GET['log_download']) && isset($_REQUEST['_wpnonce']) && ( $_GET['page'] == 'et_settings' && $_GET['sub'] == 'logging' )) {
    
    $getFileName = 'expttxt_log_' . date('d-M-Y', sanitize_text_field( $_GET['log_download'] ));
    $fileName = date('d-M-Y', sanitize_text_field( $_GET['log_download'] )) . '_expt_error_log_file.log';
    $file = $__Expt_BaseController->expt_error_log_file_PATHURL . $fileName;
    
    if( isset($_GET['del']) && $_GET['del'] == '012' . $_GET['log_download'] . '210' ) {

        if( !wp_verify_nonce( sanitize_text_field( $_REQUEST['_wpnonce'] ), "delete-" . sanitize_text_field( $_GET['log_download'] ) ) ) {
            die("ERROR");
        }

        if( file_exists($file) ) {

            unlink($file);
            update_option( "expt_rmfile", 'true', 'yes' );
            
            $redirectURL = add_query_arg( '_wpnonce', wp_create_nonce( 'delete-' . esc_attr( $getFileName ) ), admin_url(sprintf("admin.php?page=et_settings&sub=logging&rmfile=%s", esc_attr( $getFileName ))));
            header("Location: {$redirectURL}");

        } else {
            $__Expt_Notices->notice( __( 'It looks like the log file "' . esc_attr( $getFileName ) . '" not found. Please refresh this page.', 'experttexting-official' ), 'error' );
        }

    } else {

        if( !wp_verify_nonce( sanitize_text_field( $_REQUEST['_wpnonce'] ), "log-" . sanitize_text_field( $_GET['log_download'] ) ) ) {
            die("ERROR");
        }
        
        if( file_exists($file) ) {
    
            ob_clean();
            
            header('Content-Disposition: attachment; filename="' . esc_attr( $fileName ) . '"'); 
            header('Content-Type: text/plain');
    
            readfile( esc_attr( $file ) );
    
            ob_flush();
            exit;
    
        } else {
    
            $__Expt_Notices->notice( __( 'It looks like the log file "' . esc_attr($getFileName) . '" not found. Please refresh this page.', 'experttexting-official' ), 'error' );
        }

    }

} elseif( isset($_GET['rmfile']) && !empty($_GET['rmfile'] && isset($_REQUEST['_wpnonce'])) ) {

    if( !wp_verify_nonce( sanitize_text_field( $_REQUEST['_wpnonce'] ), "delete-" . sanitize_text_field( $_GET['rmfile'] ) ) ) {
        die("ERROR");
    }

    if(empty(get_option( "expt_rmfile" ))) {
        $redirect_from_del = admin_url("admin.php?page=et_settings&sub=logging");
        header("Location: {$redirect_from_del}");
        return;
    }
    
    $getFileName = sanitize_text_field( $_GET['rmfile'] );
    $__Expt_Notices->notice( __( 'File "' . esc_attr( $getFileName ) . '" has been successfully deleted.', 'experttexting-official' ), 'success' );
    delete_option( "expt_rmfile" );
}