<?php

if ( ! class_exists( 'WP_List_Table' ) ) {
    require_once( admin_url('/includes/class-wp-list-table.php') );
}

global $__Expt_NewsletterCallbacks, $__Expt_BaseController;
$etSubscribersList = new Expt_Subscribers_List();

?>
<div class="wrap bootstrap-et">
    <?php $__Expt_BaseController->plugin_et_header(); ?>
    <div class="px-3 py-2">
        <h2 class="fst-italic mb-3 mt-2"><?php _e( 'Subscribers', 'experttexting-official' ) ?> - <?php _e( 'ExpertTexting Official', 'experttexting-official' ) ?></h2>
        <?php add_thickbox(); ?>
        <div class="et-admin-btn-group">
            <a name="Add Subscriber" href='<?php esc_attr_e( admin_url("admin.php?page=et_subscribers#TB_inline?&width=400&height=230&inlineId=add-subscriber") ) ?>' class="thickbox button"><span class="dashicons dashicons-admin-users"></span><?php _e( 'Add Subscriber', 'experttexting-official' ) ?></a>
            <a href='<?php esc_attr_e( admin_url("admin.php?page=et_subscribers_group") ) ?>' class="button"><span class="dashicons dashicons-category"></span><?php _e( 'Manage Group', 'experttexting-official' ) ?></a>
            <a name="Import Subscribers" href='<?php esc_attr_e( admin_url("admin.php?page=et_subscribers#TB_inline?&width=420&height=190&inlineId=import-subscriber") ) ?>' class="thickbox button"><span class="dashicons dashicons-upload"></span><?php _e( 'Import Subscribers', 'experttexting-official' ) ?></a>
            <a name="Export Subscribers" href='<?php esc_attr_e( admin_url("admin.php?page=et_subscribers#TB_inline?&width=420&height=190&inlineId=export-subscriber") ) ?>' class="thickbox button"><span class="dashicons dashicons-download"></span><?php _e( 'Export Subscribers', 'experttexting-official' ) ?></a>
        </div>

        <!-- ADD SUBSCRIBER MODAL -->
        <div id="add-subscriber" style="display:none;">
            <form action="" class="modal_thickbox" method="post" id="add-subscriber-form">
                <div class="bootstrap-et">

                    <div class="mb-2 row">
                        <label for="et_subscribe_name" class="col-sm-2 col-form-label"><?php _e('Name', 'experttexting-official'); ?></label>
                        <div class="col-sm-10">
                            <input type="text" class="form-control alphaCharOnly" id="et_subscribe_name" name="et_subscribe_name" maxlength="50" placeholder="<?php _e('Enter Name', 'experttexting-official'); ?>" required>
                        </div>
                    </div>
                    <div class="mb-2 row">
                        <label for="et_subscribe_mobile" class="col-sm-2 col-form-label"><?php _e('Mobile', 'experttexting-official'); ?></label>
                        <div class="col-sm-10">
                            <input type="tel" class="form-control expttxt-intl-input" id="et_subscribe_mobile" name="et_subscribe_mobile" maxlength="20" placeholder="<?php _e('Enter Mobile Number', 'experttexting-official'); ?>" required>
                        </div>
                    </div>
                    <div class="mb-2 row">
                        <label for="et_group_name" class="col-sm-2 col-form-label"><?php _e('Group', 'experttexting-official'); ?></label>
                        
                        <?php $groups = $__Expt_NewsletterCallbacks::getGroups();
                        if ( $groups ): ?>
                            <div class="col-sm-10">
                                <select name="et_group_name" id="et_group_name" class="form-control">
                                    <?php foreach ($groups as $items): ?>
                                        <option value="<?php esc_attr_e( absint($items->ID) ); ?>"><?php esc_attr_e($items->name); ?></option>
                                    <?php endforeach; ?>
                                </select>
                            </div>
                        <?php else: ?>
                            <div class="col-sm-10 d-flex align-items-center justify-content-between">
                                <?php _e( 'There is no group!', 'experttexting-official' ); ?> <a class="btn btn-sm btn-success" href="<?php esc_attr_e( admin_url("admin.php?page=et_subscribers_group") ) ?>"><?php _e( 'Add Group', 'experttexting-official' ); ?></a>
                            </div>
                        <?php endif; ?>
                    </div>
                    
                    <input type="submit" class="btn btn-success w-100" name="et_add_subscribe" value="<?php _e('Add', 'experttexting-official'); ?>"/>
                    
                </div>
            </form>
        </div>
        <!-- END OF ADD SUBSCRIBER MODAL -->

        <!-- EDIT SUBSCRIBER MODAL -->
        <div id="edit-subscriber" style="display:none;">

            <form action="" class="modal_thickbox" method="post" id="edit-subscriber-form">
                <div class="bootstrap-et">

                    <div class="mb-2 row">
                        <label for="et_subscribe_name_edit" class="col-sm-2 col-form-label"><?php _e('Name', 'experttexting-official'); ?></label>
                        <div class="col-sm-10">
                            <input type="text" class="form-control alphaCharOnly" id="et_subscribe_name_edit" name="et_subscribe_name_edit" maxlength="50" placeholder="<?php _e('Enter Name', 'experttexting-official'); ?>" required>
                        </div>
                    </div>
                    <div class="mb-2 row">
                        <label for="et_subscribe_mobile_edit" class="col-sm-2 col-form-label"><?php _e('Mobile', 'experttexting-official'); ?></label>
                        <div class="col-sm-10">
                            <input type="tel" class="form-control expttxt-intl-input" id="et_subscribe_mobile_edit" name="et_subscribe_mobile_edit" maxlength="20" placeholder="<?php _e('Enter Mobile Number', 'experttexting-official'); ?>" required>
                        </div>
                    </div>
                    <div class="mb-2 row">
                        <label for="et_group_name_edit" class="col-sm-2 col-form-label"><?php _e('Group', 'experttexting-official'); ?></label>

                        <?php $groups = $__Expt_NewsletterCallbacks::getGroups();
                        if ( $groups ): ?>
                            <div class="col-sm-10">
                                <select name="et_group_name_edit" id="et_group_name_edit" class="form-control">
                                    <?php foreach ($groups as $items): ?>
                                        <option value="<?php esc_attr_e( absint($items->ID) ); ?>"><?php esc_attr_e($items->name); ?></option>
                                    <?php endforeach; ?>
                                </select>
                            </div>
                        <?php else: ?>
                            <div class="col-sm-10 d-flex align-items-center justify-content-between">
                                <?php _e( 'There is no group!', 'experttexting-official' ); ?> <a class="btn btn-sm btn-success" href="<?php esc_attr_e( admin_url("admin.php?page=et_subscribers_group") ) ?>"><?php _e( 'Add Group', 'experttexting-official' ); ?></a>
                            </div>
                        <?php endif; ?>
                    </div>  

                    <div class="mb-2 row">
                        <label for="et_subscribe_status_edit" class="col-sm-2 col-form-label"><?php _e('Status', 'experttexting-official'); ?></label>
                        <div class="col-sm-10">
                            <select name="et_subscribe_status_edit" id="et_subscribe_status_edit" class="form-control" required>
                                <option value="1"><?php _e('Active', 'experttexting-official'); ?></option>
                                <option value="0"><?php _e('Inactive', 'experttexting-official'); ?></option>
                            </select>
                        </div>
                    </div>

                    <input type="hidden" id="et_subscribe_id_edit" name="et_subscribe_id_edit" required>
                    
                    <input type="submit" class="btn btn-success w-100" name="et_update_subscribe" value="<?php _e('Update', 'experttexting-official'); ?>"/>
                    
                </div>
            </form>
        </div>
        <!-- END OF EDIT SUBSCRIBER MODAL -->

        <!-- EXPORT MODAL -->
        <div id="export-subscriber" style="display:none;">
            <form action="" onsubmit="parent.tb_remove();" class="modal_thickbox" method="post">
                <div class="bootstrap-et">

                    <div class="mb-2 row">
                        <label for="exportSelection" class="col-sm-2 col-form-label"><?php _e('Select', 'experttexting-official'); ?></label>
                        <div class="col-sm-10">
                            <select name="exportSelection" id="exportSelection" class="form-control">
                                <option value="all"><?php _e('All Subscribers', 'experttexting-official'); ?></option>
                                
                                <?php $groups = $__Expt_NewsletterCallbacks::getGroups();
                                if ( $groups ): ?>
                                    <option value="0"><?php _e('Subcribers with no groups', 'experttexting-official'); ?></option>
                                    <?php foreach ($groups as $items): ?>
                                        <option value="<?php esc_attr_e( absint($items->ID) ); ?>"><?php esc_attr_e($items->name); ?></option>
                                    <?php endforeach; ?>
                                <?php else: ?>
                                    <option disabled><?php _e('There is no group!', 'experttexting-official'); ?></option>
                                <?php endif; ?>
                            </select>
                        </div>
                    </div>

                    <div class="mb-2 row">
                        <label for="exportType" class="col-sm-2 col-form-label"><?php _e('Export to', 'experttexting-official'); ?></label>
                        <div class="col-sm-10">
                            <select name="exportType" id="exportType" class="form-control">
                                <option disabled selected><?php _e('Select type', 'experttexting-official'); ?></option>
                                <option value="XLS">Excel (.xls)</option>
                                <option value="XML">XML</option>
                                <option value="CSV">CSV</option>
                                <option value="TSV">TSV</option>
                            </select>
                        </div>
                    </div>

                    <input type="hidden" name="_wpnonce" value="<?php _e( wp_create_nonce("export-subscribe-nonce") ) ?>">
                    
                    <input type="submit" class="btn btn-success w-100" name="et_export_subscribe" value="<?php _e('Export', 'experttexting-official'); ?>"/>
                    
                </div>
            </form>
        </div>
        <!-- END OF EXPORT MODAL -->

        <!-- IMPORT MODAL -->
        <div id="import-subscriber" style="display:none;">
            <form action="" onsubmit="parent.tb_remove();" class="modal_thickbox" method="post" enctype="multipart/form-data">
                <div class="bootstrap-et">

                    <div class="mb-2 row">
                        <div class="col-sm-12">
                            <p class="p-0 pb-1">
                                <code>*.CSV</code> <?php _e('is the only acceptable format. Import a CSV file to add subscribers to list. Your CSV should include a header row with field names like', 'experttexting-official'); ?> (<b><?php _e('name', 'experttexting-official'); ?></b> <?php _e('and', 'experttexting-official'); ?> <b><?php _e('mobile', 'experttexting-official'); ?></b>)
                                <br>
                                Also, you can <a href="<?php _e( $__Expt_BaseController->plugin_url . 'assets/other/ExpertTexting_import_subscribers_template.csv') ?>"><?php _e('Download a CSV Template', 'experttexting-official'); ?></a> to get started.
                            </p>
                        </div>
                    </div>

                    <div class="mb-2 row">
                        <label for="import_sub_file" class="col-sm-2 col-form-label"><?php _e('File', 'experttexting-official'); ?></label>
                        <div class="col-sm-10">
                            <input type="file" accept=".csv" name="import_sub_file" id="import_sub_file" class="form-control p-1 px-2">
                        </div>
                    </div>

                    <div class="mb-2 row">
                        <label for="importSelection" class="col-sm-2 col-form-label"><?php _e('Group', 'experttexting-official'); ?></label>

                        <?php $groups = $__Expt_NewsletterCallbacks::getGroups();
                        if ( $groups ): ?>
                            <div class="col-sm-10">
                                <select name="importSelection" id="importSelection" class="form-control">
                                    <?php foreach ($groups as $items): ?>
                                        <option value="<?php esc_attr_e( absint($items->ID) ); ?>"><?php esc_attr_e($items->name); ?></option>
                                    <?php endforeach; ?>
                                </select>
                            </div>
                        <?php else: ?>
                            <div class="col-sm-10 d-flex align-items-center justify-content-between">
                                <?php _e( 'There is no group!', 'experttexting-official' ); ?> <a class="btn btn-sm btn-success" href="<?php esc_attr_e( admin_url("admin.php?page=et_subscribers_group") ) ?>"><?php _e( 'Add Group', 'experttexting-official' ); ?></a>
                            </div>
                        <?php endif; ?>
                    </div>

                    <div class="mb-2 row">
                        <div class="col-sm-10">
                            <div class="form-check">
                                <input class="form-check-input" type="checkbox" id="ignoreDuplicate" name="ignoreDuplicate">
                                <label class="form-check-label" for="ignoreDuplicate"><?php _e('Ignore duplicate subscribers if they exist in other groups.', 'experttexting-official'); ?></label>
                            </div>
                        </div>
                    </div>

                    <input type="hidden" name="_wpnonce" value="<?php _e( wp_create_nonce("import-subscribe-nonce") ) ?>">
                    
                    <input type="submit" class="btn btn-success w-100" name="et_import_subscribe" value="<?php _e('Import', 'experttexting-official'); ?>"/>
                    
                </div>
            </form>
        </div>
        <!-- END OF IMPORT MODAL -->

        <form id="subscribers_search" method="get">
            <input type="hidden" name="page" value="<?php esc_attr_e($_REQUEST['page']) ?>"/>
            <?php
            $etSubscribersList->prepare_items();
            $etSubscribersList->render();
            $etSubscribersList->search_box(__('Search', 'experttexting-official'), 'search_id');
            $etSubscribersList->display();
            ?>
        </form>
    </div>
</div>

<?php

class Expt_Subscribers_List extends WP_List_Table {

    protected $perPage;
    protected $count;
    var $data;
    public $subId;

    public $__Expt_NewsletterCallbacks, $__Expt_Notices;

    /** Class constructor */
    public function __construct() {

        global $__Expt_NewsletterCallbacks;
        global $__Expt_Notices;

        $this->__Expt_NewsletterCallbacks = $__Expt_NewsletterCallbacks;
        $this->__Expt_Notices = $__Expt_Notices;

        parent::__construct( [
        'singular' => __( 'Subscriber', 'experttexting-official' ), //singular name of the listed records
        'plural' => __( 'Subscribers', 'experttexting-official' ), //plural name of the listed records
        'ajax' => false //should this table support ajax?
        
        ] );

        $this->data = $this->table_data();
        $this->count = count($this->data);
        $this->perPage = 10;

    }

    
    /**
     * Prepare the items for the table to process
     *
     * @return Void
     */
    public function prepare_items() {

        /** Process bulk action */
        $this->process_bulk_action();

        $columns = $this->get_columns();
        $hidden = $this->get_hidden_columns();
        $sortable = $this->get_sortable_columns();
        
        $perPage = $this->perPage;
        $currentPage = $this->get_pagenum();
        
        $data = $this->data;
        usort( $data, array( $this, 'sort_data' ) );
        
        $totalItems = $this->count;
        
        $this->set_pagination_args( array(
            'total_items' => $totalItems,
            'per_page'    => $perPage
            ) );

        $data = array_slice($data,(($currentPage-1)*$perPage),$perPage);
            
        $this->_column_headers = array($columns, $hidden, $sortable);
        $this->items = $data;

    }

    /**
     * Override the parent columns method. Defines the columns to use in your listing table
     *
     * @return Array
     */
    public function get_columns() {

        $columns = array(
            'cb' => '<input type="checkbox" />',
            'name' => __( 'Name', 'experttexting-official' ),
            'mobile' => __( 'Mobile', 'experttexting-official' ),
            'group' => __( 'Group', 'experttexting-official' ),
            'date' => __( 'Date', 'experttexting-official' ),
            'status' => __( 'Status', 'experttexting-official' ),
            'activate_key' => __( 'Activation Code', 'experttexting-official' ),
        );

        return $columns;
    }

    /**
     * Define which columns are hidden
     *
     * @return Array
     */
    public function get_hidden_columns() {

        return array(
            'ID' => 'ID',
        );
    }

    /**
     * Define the sortable columns
     *
     * @return Array
     */
    public function get_sortable_columns() {

        $s_columns = array (
            'ID' => array('ID', true),
            'name' => array( 'name', false),
            'mobile' => array( 'mobile', false),
            'group' => array( 'group', false),
            'date' => array( 'date', false),
            'status' => array( 'status', false),
            'activate_key' => array( 'activate_key', false),
        );
        return $s_columns;

    }

    /**
    * Returns an associative array containing the bulk action
    *
    * @return Array
    */
    public function get_bulk_actions() {

        $actions = [
            'bulk-delete' => 'Delete'
        ];

        $groups = $this->__Expt_NewsletterCallbacks::getGroups();
        if ( $groups ? count($groups) : false ) {

            foreach ($groups as $items) {
                $actions['move_to_' . absint($items->ID)] = sprintf(__('Move to Group > (%s)', 'experttexting-official'), esc_attr($items->name));
            }
        }
        
        return $actions;
    }


    public function process_bulk_action() {

        global $wpdb, $__Expt_BaseController;
        $notify = array();

        //Detect when a bulk action is being triggered...
        // Search action
        if (isset($_GET['s'])) {
            $prepare = $wpdb->prepare("SELECT * from `{$wpdb->prefix}et_subscribes` WHERE name LIKE %s OR mobile LIKE %s", '%' . $wpdb->esc_like($_GET['s']) . '%', '%' . $wpdb->esc_like($_GET['s']) . '%');
            if(!$prepare) {

                if( $wpdb->last_error ) {
                    $__Expt_BaseController->save_expt_wpdb_log();
                }
            }
            $this->data  = $this->table_data($prepare);
            $this->count = count($this->data);
        }

        if ( 'delete' === $this->current_action() ) {
        
            $res = $wpdb->delete($wpdb->prefix . "et_subscribes", array('ID' => absint($_GET['subscriber'])));
            if ($res) {
                $this->data  = $this->table_data();
                $this->count = count($this->data);

                $notify = array('result' => 'success', 'message' => __('Subscriber has been removed.', 'experttexting-official'));
            }

        }
        
        // If the delete bulk action is triggered
        if ('bulk-delete' == $this->current_action() ) {
            if(isset($_GET['id'])) {

                $bulk_delete = $__Expt_BaseController->expt_sanitize_array_data( $_GET['id'] );
            
                foreach ($bulk_delete as $id) {
                    $res = self::delete_subscriber($id);
                }

                if($res) {

                    $this->data  = $this->table_data();
                    $this->count = count($this->data);
                    $notify = array('result' => 'success', 'message' => __('Subscriber(s) has been removed.', 'experttexting-official'));
                } else {
                    
                    $notify = array('result' => 'error', 'message' => __('Unable to remove subscriber(s). Please try again or contact ExpertTexting support if issue persists.', 'experttexting-official'));
                }

            } else {

                $notify = array('result' => 'error', 'message' => __('No subscriber selected.', 'experttexting-official'));
            }
        }

        if (false !== strpos($this->current_action(), 'move_to_')) {
            $new_group_id = substr($this->current_action(), 8);
            $new_group = $this->__Expt_NewsletterCallbacks::getGroup($new_group_id);
            if ($new_group) {
                $get_ids = isset($_GET['id']) ? array_map('sanitize_text_field', $_GET['id']) : '';
                if($get_ids) {

                    foreach ($get_ids as $id) {
                        $updatemove = $wpdb->update( $wpdb->prefix . "et_subscribes", array('group_ID' => esc_attr($new_group->ID)), array('ID' => intval($id)) );
                    }

                    if( !$updatemove ) {

                        if( $wpdb->last_error ) {
                            $__Expt_BaseController->save_expt_wpdb_log();
                        }
                    }

                    $this->data  = $this->table_data();
                    $this->count = count($this->data);
                    
                    $notify = array('result' => 'success', 'message' => __('Subscriber(s) moved to ('. esc_attr($new_group->name) .') group.', 'experttexting-official' ));
                } else {

                    $notify = array('result' => 'error', 'message' => __('No subscriber(s) selected.', 'experttexting-official' ));
                }
            }
        }

        if ('edit-sub' == $this->current_action()) {
            $subId = esc_attr($_GET['subId']);
            
        }

        if (isset($notify['message'])) {
            $this->__Expt_Notices->notice( esc_attr($notify['message']), esc_attr($notify['result']) );
        }

    }


    /**
    * Delete a subscriber record.
    *
    * @param int $id subscriber ID
    */
    public static function delete_subscriber( $id ) {
        global $wpdb;
        
        $wpdb->delete(
        "{$wpdb->prefix}et_subscribes",
        [ 'ID' => $id ],
        [ '%d' ]
        );

        return array('result' => 'success', 'message' => __('Subscriber has been removed.', 'experttexting-official'));

    }


    /**
    * Render the bulk edit checkbox
    *
    * @param array $item
    *
    * @return string
    */
    function column_cb( $item ) {
        
        return sprintf(
        '<input type="checkbox" name="id[]" value="%s" />', $item['ID']
        );

    }

    /**
    * Returns the count of records in the database.
    *
    * @return null|string
    */
    public static function record_count() {
        global $wpdb;
        
        $sql = "SELECT COUNT(*) FROM {$wpdb->prefix}et_subscribes";
        
        return $wpdb->get_var( $sql );
    }

    /** Text displayed when no subscriber data is available */
    public function no_items() {
        _e( 'No subscribers available.', 'experttexting-official' );
    }


    /**
    * Retrieve subscriber’s data from the database
    *
    * @return mixed
    */
    
    // Table Data

    public function table_data( $sql = '' ) {

        $data = array();        

        global $wpdb, $__Expt_BaseController;

        if ( !$sql ) {
            $sql = "SELECT * FROM {$wpdb->prefix}et_subscribes";
        }

        $wpdb->show_errors();

        $result = $wpdb->get_results( $sql );

        if(!$result) {

            if( $wpdb->last_error ) {
                $__Expt_BaseController->save_expt_wpdb_log();
            }
        }

        // loop over the array of record IDs
        foreach ( $result as $record ) {

            $data[] = array(
                'ID' => $record->{"ID"},
                'name' => $record->{"name"},
                'mobile' => $record->{"mobile"},
                'group' => $record->{"group_ID"},
                'date' => $record->{"date"},
                'status' => $record->{"status"},
                'activate_key' => $record->{"activate_key"}
            );
        }

        return $data;
    }


    /**
     * Define what data to show on each column of the table
     *
     * @param  Array $item        Data
     * @param  String $column_name - Current column name
     *
     * @return Mixed
     */
    public function column_default( $item, $column_name )
    {
        switch( $column_name ) {
            
            case 'name':
            case 'mobile':
                return $item[ $column_name ];

            case 'group':
                $group = $this->__Expt_NewsletterCallbacks::getGroup($item[ $column_name ]);
                if ($group) {
                    return $group->name;
                } else {
                    return '-';
                }
                
            case 'date':
                return sprintf(__('%s <span class="et_time">%s</span>'), date_i18n('Y-m-d', strtotime($item[$column_name])), date_i18n('H:i', strtotime($item[$column_name])));

            case 'status':
                return ($item[$column_name] == '1' ?  "<strong class='text-success'>". __( 'Active', 'experttexting-official' ) ."</strong>" : "<strong class='text-danger'>". __( 'Inactive', 'experttexting-official' ) ."</strong>");

            case 'activate_key':
                return $item[ $column_name ] ? $item[ $column_name ] : '-';

            default:
                return print_r( $item, true ) ;
        }
    }


    /**
    * Method for name column
    *
    * @param array $item an array of DB data
    *
    * @return string
    */
    function column_name( $item ) {
       
        $title = $item['name'];
        
        $actions = [
            'edit'   => sprintf( '<a name="Edit Subscriber" class="thickbox" href="?page=et_subscribers#TB_inline?&width=400&height=290&inlineId=edit-subscriber" onclick="edit_subscriber_params(%d,\'%s\',\'%s\',\'%s\',\'%s\')">' . __('Edit', 'experttexting-official') . '</a>', $item['ID'], $item['name'], $item['mobile'], $item['status'], $item['group']),
            'delete' => sprintf( '<a href="?page=%s&action=%s&subscriber=%s" onclick="con = confirm(\'' . __('Are you sure you want to delete this subscriber?', 'experttexting-official') .'\r\n\r\n'. __('Note: This action cannot be undone.', 'experttexting-official') . '\'); if(con != true){return false;}">' . __('Delete', 'experttexting-official') . '</a>', esc_attr( $_REQUEST['page'] ), 'delete', absint( $item['ID'] ))
        ];
        
        //Return the title contents
        return sprintf('%1$s %3$s',
            /*$1%s*/
            $item['name'],
            /*$1%s*/
            $item['ID'],
            /*$2%s*/
            $this->row_actions($actions)
        );
    }

    /**
     * Allows you to sort the data by the variables set in the $_REQUEST
     *
     * @return Mixed
     */
    private function sort_data( $a, $b ) {

        // Set defaults
        $def_orderby = 'date';
        $def_order = 'desc';

        $orderby = ( !empty( $_REQUEST['orderby'] ) ) ? sanitize_text_field( $_REQUEST['orderby'] ) : $def_orderby;
        $order = ( !empty( $_REQUEST['order'] ) ) ? sanitize_text_field( $_REQUEST['order'] ) : $def_order;
        $result = strnatcmp( $a[$orderby], $b[$orderby] );

        return ( $order==='asc' ) ? $result : -$result;
    }


    /**
     * Renders some Actions
     * 
     */
    public function render() {

        global $__Expt_BaseController;

        // Add subscriber
        if (isset($_POST['et_add_subscribe'])) {

            $et_subscribe_mobile = isset($_POST['et_subscribe_mobile']) ? sanitize_text_field( $_POST['et_subscribe_mobile'] ) : '';
            $et_subscribe_name = isset($_POST['et_subscribe_name']) ? sanitize_text_field( $_POST['et_subscribe_name'] ) : '';

            if ( $__Expt_BaseController->activated( 'et_menu', 'intl_tel_input_chk' ) ) {

                $dialcode = isset($_POST["et_sms_mob_dial_code"]) && !empty($_POST["et_sms_mob_dial_code"]) ? sanitize_text_field( $_POST["et_sms_mob_dial_code"] ) : '';
                if( !$dialcode ) {
                    $this->__Expt_Notices->notice( __('The entered mobile number is invalid.', 'experttexting-official'), 'error' );
                    return;
                }

                $et_subscribe_mobile = $dialcode;
            }

            $group = isset($_POST['et_group_name']) ? sanitize_text_field( $_POST['et_group_name'] ) : '';
            if ($group) {
                $result = $this->__Expt_NewsletterCallbacks::addSubscriber( $et_subscribe_name, $et_subscribe_mobile, $group );
            } else {
                $result = $this->__Expt_NewsletterCallbacks::addSubscriber( $et_subscribe_name, $et_subscribe_mobile );
            }

            $this->data  = $this->table_data();
            $this->count = count($this->data);
            
            self::prepare_items();

            if(isset($result['message'])) {
                $this->__Expt_Notices->notice( esc_attr($result['message']), esc_attr($result['result']) );
            }
        }

        ?>

        <script>
        // Edit Subscriber JS
        function edit_subscriber_params( id, name, mobile, status, group_id ) {
            
            if ( id != null ) {
                jQuery("#et_subscribe_id_edit").val(id);
                jQuery("#et_subscribe_name_edit").val(name);
                jQuery("#et_subscribe_mobile_edit").val(mobile);
                jQuery("#et_group_name_edit").val(group_id);
                jQuery("#et_subscribe_status_edit").val(status);
            }
        }
        </script>

        <?php

        // Edit Subscriber
        if (isset($_POST['et_update_subscribe'])) {

            $update_id = isset($_POST['et_subscribe_id_edit']) ? sanitize_text_field($_POST['et_subscribe_id_edit']) : "";
            $update_name = isset($_POST['et_subscribe_name_edit']) ? sanitize_text_field($_POST['et_subscribe_name_edit']) : "";
            $update_mobile = isset($_POST['et_subscribe_mobile_edit']) ? sanitize_text_field($_POST['et_subscribe_mobile_edit']) : "";

            if ( $__Expt_BaseController->activated( 'et_menu', 'intl_tel_input_chk' ) ) {

                $dialcode = isset($_POST["et_sms_mob_dial_code"]) && !empty($_POST["et_sms_mob_dial_code"]) ? sanitize_text_field( $_POST["et_sms_mob_dial_code"] ) : '';
                if( !$dialcode ) {
                    $this->__Expt_Notices->notice( __('The entered mobile number is invalid.', 'experttexting-official'), 'error' );
                    return;
                }

                $update_mobile = $dialcode;
            }

            $update_group = isset($_POST['et_group_name_edit']) ? sanitize_text_field($_POST['et_group_name_edit']) : "";
            $update_status = isset($_POST['et_subscribe_status_edit']) ? sanitize_text_field($_POST['et_subscribe_status_edit']) : "";

            $result = $this->__Expt_NewsletterCallbacks::updateSubscriber( $update_id, $update_name, $update_mobile, $update_group, $update_status);

            $this->data  = $this->table_data();
            $this->count = count($this->data);
            
            self::prepare_items();

            if(isset($result['message'])) {
                $this->__Expt_Notices->notice( esc_attr($result['message']), esc_attr($result['result']) );
            }
        }
        
    }
    
}


