<?php

global $__Expt_BaseController;

?>

<div class="wrap bootstrap-et">
    
    <div class="row justify-content-center mt-3 mx-0">
        <div class="col-md-8">
            <?php $__Expt_BaseController->plugin_et_header_logo('w-50', 'max-width: 200px;'); ?>
            
            <div class="card p-3">
                <div class="text-center">
                    <h4>Welcome to ExpertTexting Official Plugin v<?php esc_attr_e($__Expt_BaseController->plugin_version); ?></h4>
                    <p>Thank you for choosing ExpertTexting! A simple and powerful texting plugin for WordPress.</p>
                </div>
                <div class="my-2 border">
                    <img class="w-100" src="<?php _e( $__Expt_BaseController->plugin_url . "assets/img/banner-772x250.jpg" ); ?>" alt="banner-772x250.png">
                </div>

                <p>With this ExpertTexting plugin, you can add the ability of sending SMS & notifications to your WordPress newsletter subscribers or users, and keep them updated on the latest posts and updates.</p>

                <div class="mt-4">
                    <div class="card p-0">
                        <div class="card-body">
                            <h4 class="m-0">Welcome to ExpertTexting v<?php esc_attr_e($__Expt_BaseController->plugin_version); ?></h4>
                            <hr>
                            <p class="mb-3">Thank you for updating! ExpertTexting v<?php esc_attr_e($__Expt_BaseController->plugin_version); ?> makes you and your customers more integrated with the seamless messaging experience.</p>
                            <div class="card p-0">
                                <div class="card-header">
                                    <h6 class="m-0">Changes in v<?php esc_attr_e($__Expt_BaseController->plugin_version); ?></h6>
                                </div>
                                <div class="card-body">
                                    <ul style="list-style-type: disc;" class="ps-3 m-0">
                                        <li>Fixed bugs.</li>
                                        <li>Added message sent status (To check whether the message was successfully sent or not).</li>
                                        <li>Added Mobile number validation feature (You need to enable 'International Mobile Number Input' in Feature settings).</li>
                                        <li>Added 'BuddyPress' in Integrations</li>
                                        <li>Added 'Gravity Forms' in Integrations</li>
                                        <li>Added 'Quform' in Integrations</li>
                                        <li>Added privacy option in Newsletter form. (You need to enable 'Privacy Policy Checkbox' in Feature settings)</li>
                                    </ul>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="mt-4">
                    <h6>By using the ET Plugin, you can enjoy the following features:</h6>
    
                    <ul style="list-style-type: disc;">
                        <li>Send SMS to your users' numbers or other numbers</li>
                        <li>Send SMS automatically to users and admins as required</li>
                        <li>Use the ExpertTexting Widget to gain subscribers</li>
                        <li>Login with mobile number and verification of mobile number using OTP</li>
                        <li>Increase the security by 2FA (Two-Factor Authentication) or Two-Step Verification</li>
                        <li>And many more...</li>
                    </ul>
                </div>

                <p>This plugin is absolutely free! You just need to have an ExpertTexting account.</p>
                <br>
                <p>Watch the video below to know how you can get started with ExpertTexting WordPress Plugin.</p>

                <div class="embed-responsive embed-responsive-16by9 mt-2">
                    <iframe class="embed-responsive-item w-100" width="768" height="432" src="https://www.youtube.com/embed/pEHPbWZ46O0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
                </div>

                <div class="d-flex flex-column flex-md-row justify-content-center mt-4 text-center">
                    <a class="button me-md-2" href="<?php esc_attr_e( admin_url('admin.php?page=et_settings&sub=api') ); ?>">Setup an API Settings</a>
                    <a class="button me-md-2" href="<?php esc_attr_e( admin_url('admin.php?page=et_menu') ); ?>">Go to Dashboard</a>
                    <a class="button" target="_blank" href="https://www.experttexting.com/contact-us/">Contact ExpertTexting</a>
                </div>
                
            </div>

            <div class="card p-3">
                <h6>Features</h6>

                <ul style="list-style-type: disc;">
                    <li>Send SMS to your subscribers, WordPress users, and other mobile numbers</li>
                    <li>Subscribe to the SMS newsletter </li>
                    <li>Send notification SMS to the admins</li>
                    <li>Send activation codes to subscribers when they subscribe to your newsletters</li>
                    <li>Send SMS notifications to the subscribers when a new post is published</li>
                    <li>Receive SMS notifications when a new user is registered</li>
                    <li>Receive SMS notifications when new comments are posted</li>
                    <li>Receive SMS notifications when users log in to WordPress</li>
                    <li>Receive SMS notifications when there is a new subscriber</li>
                    <li>Increase the security by 2FA (Two-Factor Authentication) or Two-Step Verification</li>
                    <li>Login with mobile number and verification of mobile number using OTP</li>
                    <li>Validate mobile number</li>
                    <li>Supported WP Widget to help subscribe to SMS newsletters</li>
                    <li>Supported Shortcode for showing SMS newsletters to subscribers [et-sub-form title='YOUR TITLE' desc='YOUR DESCRIPTION']</li>
                    <li>Supported WordPress Actions</li>
                    <li>Supported WordPress Filters</li>
                    <li>Integrate with</li>
                    <ul style="list-style-type: circle;">
                        <li><b>Contact form 7</b></li>
                        <li><b>WooCommerce</b></li>
                        <li><b>Easy Digital Downloads</b></li>
                        <li><b>BuddyPress</b></li>
                        <li><b>Gravity Forms</b></li>
                        <li><b>Quform</b></li>
                    </ul>
                    <li>Importing/Exporting Subscribers.</li>
                    <li>Supported WordPress Hooks</li>
                    <li>More features and integrations will be added in future versions.</li>
                </ul>

                <div class="d-flex flex-column flex-md-row justify-content-center mt-4 text-center">
                    <a class="button me-md-2" href="<?php esc_attr_e( admin_url('admin.php?page=et_settings&sub=api') ); ?>">Setup an API Settings</a>
                    <a class="button me-md-2" href="<?php esc_attr_e( admin_url('admin.php?page=et_menu') ); ?>">Go to Dashboard</a>
                    <a class="button" target="_blank" href="https://www.experttexting.com/contact-us/">Contact ExpertTexting</a>
                </div>
            </div>

        </div>
    </div>

</div>
