<?php

/**
 * @package ExpertTextingOfficial
 */

namespace ExptTxt\Expt_Base;

class Expt_Enqueue extends Expt_BaseController {
    
    public function register() {

        add_action( 'admin_enqueue_scripts', array($this, 'enqueue_bootstrap_scripts'), 30, 1 );
        add_action( 'admin_enqueue_scripts', array($this, 'enqueue'), 30, 1 );

        if( $this->activated( 'et_menu', 'intl_tel_input_chk' ) ) {
            add_action( 'admin_enqueue_scripts', array($this, 'enqueue_intlTelInput'), 30, 1 );
            add_action( 'wp_enqueue_scripts', array($this, 'enqueue_intlTelInput'), 30, 1 );
            add_action( 'login_enqueue_scripts', array($this, 'enqueue_intlTelInput'), 30, 1 );
            add_action( 'login_enqueue_scripts', array($this, 'enqueue_client'), 30, 1 );
        }
        
        add_action( 'wp_enqueue_scripts', array($this, 'enqueue_client'), 30, 1 );

        add_action('in_admin_header', function () {
            $et_get_current_screen = get_current_screen()->base;
            if( strpos( $et_get_current_screen, 'experttexting_page' ) !== false || $et_get_current_screen === 'toplevel_page_et_menu' || $et_get_current_screen === 'dashboard_page_et-plugin-welcome' ) {
                remove_all_actions('admin_notices');
                remove_all_actions('all_admin_notices');
            }
        });
    }

    function enqueue() {

        $et_get_current_screen = get_current_screen()->base;
        if( strpos( $et_get_current_screen, 'experttexting_page' ) !== false || $et_get_current_screen === 'toplevel_page_et_menu' || $et_get_current_screen === 'dashboard_page_et-plugin-welcome' ) {
            add_action('admin_head', function () {
                ?>
                <style type="text/css">
                    #wpcontent {
                        padding: 0 !important;
                    }
                </style>
                <?php
            });
        }

        // Admin
        wp_enqueue_style( 'ETStyleAdmin', $this->plugin_url . 'assets/et_style_admin.css', true, $this->plugin_version );
        wp_enqueue_script( 'ETScriptAdmin', $this->plugin_url . 'assets/et_script_admin.js', array('jquery'), $this->plugin_version, true );
        wp_enqueue_style( 'et_ChosenCss', $this->plugin_url . 'assets/chosen.css', true, $this->plugin_version );
        wp_enqueue_script( 'et_ChosenJquery', $this->plugin_url . 'assets/chosen.jquery.js', array('jquery'), $this->plugin_version, true );

    }

    function enqueue_client() {

        // Client
        wp_enqueue_style( 'ETStyleClient', $this->plugin_url . 'assets/et_style.css', true, $this->plugin_version );
        wp_enqueue_script( 'ETScriptClient', $this->plugin_url . 'assets/et_script.js', array('jquery'), $this->plugin_version, true );
    }

    function enqueue_bootstrap_scripts($hook) {

        // Bootstrap
        wp_enqueue_style( 'ETbootstrap', $this->plugin_url . 'assets/bootstrap/bootstrap.et.css', true, $this->plugin_version );
        wp_enqueue_script( 'ETpopper', $this->plugin_url . 'assets/bootstrap/popper.min.js', array('jquery'), $this->plugin_version, true );
        wp_enqueue_script( 'ETbootstrap-js', $this->plugin_url . 'assets/bootstrap/bootstrap.js', array('jquery'), $this->plugin_version, true );
    }

    function enqueue_intlTelInput() {

        // intlTelInput
        wp_enqueue_style( 'ETintlTelInputStyle', $this->plugin_url . 'assets/intlTelInput.css', true, $this->plugin_version );
        wp_enqueue_script( 'ETintlTelInputScript', $this->plugin_url . 'assets/intlTelInput.js', array('jquery'), $this->plugin_version, true );
        wp_enqueue_script( 'ETintlTelInputScript_JS', $this->plugin_url . 'assets/et_intlTelInput.js', array('ETintlTelInputScript'), $this->plugin_version, true );

        // Localize the intlTelInput
        $et_intl_tel_input = array();
        $expt_intl_tel_input = $this->expt_escape_array_data( get_option( 'et_menu' ) );
        $expt_only_countries = isset( $expt_intl_tel_input['intl_tel_input_only_countries'] ) ? $expt_intl_tel_input['intl_tel_input_only_countries'] : '';
        $expt_preferred_countries = isset( $expt_intl_tel_input['intl_tel_input_preferred_countries'] ) ? $expt_intl_tel_input['intl_tel_input_preferred_countries'] : '';
        $expt_national_mode = $this->activated( 'et_menu', 'intl_tel_input_national_mode' );
        $expt_separate_dialcode = $this->activated( 'et_menu', 'intl_tel_input_separate_dialcode' );

        if ( $expt_only_countries ) {
            $et_intl_tel_input['only_countries'] = $expt_only_countries;
        } else {
            $et_intl_tel_input['only_countries'] = '';
        }

        if ( $expt_preferred_countries ) {
            $et_intl_tel_input['preferred_countries'] = $expt_preferred_countries;
        } else {
            $et_intl_tel_input['preferred_countries'] = '';
        }

        if ( $expt_national_mode ) {
            $et_intl_tel_input['national_mode'] = true;
        } else {
            $et_intl_tel_input['national_mode'] = false;
        }

        if ( $expt_separate_dialcode ) {
            $et_intl_tel_input['separate_dial'] = true;
        } else {
            $et_intl_tel_input['separate_dial'] = false;
        }

        $et_intl_tel_input['util_js'] = $this->plugin_url . 'assets/utils.js';

        wp_localize_script('ETintlTelInputScript_JS', 'et_intl_tel_input', $et_intl_tel_input);
    }

}