<?php

/**
 * @package ExpertTextingOfficial
 */

namespace ExptTxt\Expt_Base;

class Expt_SettingsLink extends Expt_BaseController {
    
    public function register() {
        add_filter( "plugin_action_links_$this->plugin_basename", array( $this, 'settings_link' ) );
        add_filter( 'plugin_row_meta', array( $this, 'meta_links' ), 0, 2 );
    }

    public function settings_link( $links ) {
        // Custom settings link
        $settings_link = '<a href="' . admin_url("admin.php?page=et_settings") . '">Settings</a>';
        array_push( $links, $settings_link );
        return $links;
    }

    public function meta_links( $links, $file ) {

        if( $file == 'experttexting-official/experttextingofficial.php' ) {
            $et_plugin_rate_page = 'http://wordpress.org/support/view/plugin-reviews/experttexting-official?rate=5#postform';
            $et_plugin_page = 'https://www.experttexting.com/wp-plugin/';

            $new_links = array(
                'et_plugin_rate_page' => '<a href="' . $et_plugin_rate_page . '" target="_blank" title="Click here to rate and review this plugin on WordPress.org">Rate this plugin</a>',
                'et_plugin_page' => '<a href="' . $et_plugin_page . '" target="_blank" title="Click here to visit ExpertTexting Plugin page">Visit plugin page</a>'
            );
         
            $links = array_merge( $links, $new_links );
        }

        return $links;
    }
}