<?php

/**
 * @package ExpertTextingOfficial
 */

namespace ExptTxt;

final class Expt_Init {
    
    /**
     * Store all the classes inside an array
     * @return [array] [full list of classes]
     */

    public static function get_services() {

        return [
            Expt_Base\Expt_Enqueue::class,
            Expt_Base\Expt_SettingsLink::class,
            Expt_Base\Expt_WidgetController::class,
            Expt_Base\Expt_ApiController::class,
            Expt_Base\Expt_Features::class,
            Expt_Base\Expt_NotificationsController::class,
            Expt_Base\Expt_IntegrationController::class,
            Expt_Base\Expt_ImportExportController::class,
            Expt_Pages\Expt_Dashboard::class,
        ];
    }

    /**
     * Loop through the classes, initialize them, 
     * and call the register() method if it exists
     */

    public static function register_services() {
        foreach ( self::get_services() as $class ) {
            $service = self::instantiate( $class );

            if ( method_exists( $service, 'register' ) ) {
                $service->register();
            }
        }
    }

    /**
     * Initialize the class
     * @param [class $class] [class from the services]
     * @return [class instance] [new instance of the class]
     */

    private static function instantiate( $class ) {
        $service = new $class();
        return $service;
    }
}