<?php

/**
 * @package ExpertTextingOfficial
 */
/*
Plugin Name:       ExpertTexting Official
Description:       With this ExpertTexting plugin, you can add the ability of sending SMS & notifications to your WordPress newsletter subscribers or users, and keep them updated on the latest posts and updates.
Version:           1.2.0
Author:            ExpertTexting
Author URI:        experttexting.com
 */

ob_start();

// If this file is called directly, abort.
if (!defined('ABSPATH')) {
	die('Hey you can\'t access this file...');
}

// Require once the Composer Autoload
if ( file_exists( dirname( __FILE__ ) . '/vendor/autoload.php' ) ) {
	require_once dirname( __FILE__ ) . '/vendor/autoload.php';
}

// Include all the Global Instance Variables
include_once dirname( __FILE__ ) . "/ExptTxt/Expt_GlobalVars.php";

// Check Expt Logs
$__Expt_BaseController->checkFiles();
$__Expt_BaseController->expt_error_log();

/**
 * The code that runs during plugin activation
 */
function activate_experttexting_plugin() {
	ExptTxt\Expt_Base\Expt_Activate::activate();

	if( get_transient( '__expttxt_need_upgrade' ) ) {
		delete_transient( '__expttxt_need_upgrade' );
	}
	
}
register_activation_hook( __FILE__, 'activate_experttexting_plugin' );


/**
 * The code that runs during plugin update
 */
function upgrade_experttexting_plugin( $upgrader_object, $options ) {
	
	$current_plugin_path_name = plugin_basename( __FILE__ );
	ExptTxt\Expt_Base\Expt_Activate::upgrade( $upgrader_object, $options, $current_plugin_path_name );

	if( get_transient( '__expttxt_need_upgrade' ) ) {
		delete_transient( '__expttxt_need_upgrade' );
	}

}
add_action( 'upgrader_process_complete', 'upgrade_experttexting_plugin', 10, 2);


/**
 * The code that runs during plugin deactivation
 */
function deactivate_experttexting_plugin() {
	ExptTxt\Expt_Base\Expt_Deactivate::deactivate();

}
register_deactivation_hook( __FILE__, 'deactivate_experttexting_plugin' );


/**
 * Initialize all the core classes of the plugin
 */
add_action( 'plugins_loaded', 'init_all_expt_classes' );
function init_all_expt_classes() {
	if ( class_exists( 'ExptTxt\\Expt_Init' ) ) {
		ExptTxt\Expt_Init::register_services();
	}
}


/**
 * Display Welcome screen when plugin successfully installed and activated
 */
$Expt_Activate = new ExptTxt\Expt_Base\Expt_Activate;
$Expt_Activate->activated_display();


/**
 * Upgrade plugin if needed
 * @since 1.2.0
 */
if( !get_transient( '__expttxt_need_upgrade' ) ) {
	$Expt_Activate->upgrade_inner_plugin();
}


/**
 * Runs to check situation and print notices
 */
add_action( 'admin_footer', 'global_fn' );
function global_fn() {
	if ( is_super_admin() && is_admin() ) {
		$Global_Notices = new ExptTxt\Expt_Base\Expt_Global_Notices;
		$Global_Notices->registry();
	}
}